DSS.types = {};
DSS.types.dsuid = {};

DSS.types.dsuid.dsuid_from_dsid = function(dSID) {
	// copy the first 6 bytes (12 characters to the new dsuid
	var dSUID = dSID.slice(0, 12);
	// insert 4 bytes of 0
	dSUID += "00000000";
	// append the remaining 6 bytes (12 chars) of the dsid
	dSUID += dSID.slice(12, 24);
	// finaly add 1 byte of 0
	dSUID += "00";
	return dSUID;
};
DSS.types.dsuid.dsuid_to_dsid = function(dSUID) {
	var dSID = undefined;
	if (dSUID.slice(12, 20) === "00000000") {
		dSID = dSUID.slice(0, 12) + dSUID.slice(20, 32);
	}
	return dSID;
};
DSS.types.dsuid.isDSUID = function(id) {
	if (id.length === 34) {
		return true;
	} else {
		return false;
	}
};
DSS.types.dsuid.isDSID = function(id) {
	if (id.length === 24) {
		return true;
	} else {
		return false;
	}
};
DSS.types.dsuid.shortdSUID = function(dsuid) {
	return dsuid.slice(dsuid.length - 10, dsuid.length - 2);
};


dss = {};

dss.version=1;

dss.unescapeProperty = function  (sString) {
	if (typeof sString == 'string')
	return sString.replace(new RegExp("&amp;", 'g'),"&")
	               .replace(new RegExp("&gt;", 'g'),">")
	               .replace(new RegExp("&quot;", 'g'),'"')
	               .replace(new RegExp("&#039;", 'g'),"'")
    			   .replace(new RegExp("&lt;", 'g'),"<");
	else 
		return sString;
};

dss.escapeProperty = function  (sString) {
    if (typeof sString == 'string')
    return sString.replace(new RegExp("&", 'g'),"&amp;")
                   .replace(new RegExp(">", 'g'),"&gt;")
                   .replace(new RegExp('"', 'g'),"&quot;")
                   .replace(new RegExp("'", 'g'),"&#039;")
                   .replace(new RegExp("<", 'g'),"&lt;");
    else 
        return sString;
};

dss.validValue={ok:0,
    temporaryWrong:1,
    completlyWrong:2};


dss.ajaxSyncRequest = function(surl, params) {
    var xmlHttp = null;
    params.a = Math.random();

    var paramString = "?";

    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + "&";
    }

    if (typeof XMLHttpRequest != 'undefined') {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                xmlHttp = null;
            }
        }
    }
    if (xmlHttp) {
        xmlHttp.open('GET', surl + paramString, false);
        xmlHttp.send(null);
        return xmlHttp.responseText.replace(/-nan/g, '0');
    }
};

dss.ajaxAssyncRequestWithoutAnswer = function(surl, params, callback) {
    var xmlHttp = null;
    params.a = Math.random();

    var paramString = "?";

    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + "&";
    }

    if (typeof XMLHttpRequest != 'undefined') {
        xmlHttp = new XMLHttpRequest();
    }
    if (!xmlHttp) {
        try {
            xmlHttp = new ActiveXObject("Msxml2.XMLHTTP");
        } catch (e) {
            try {
                xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
            } catch (e) {
                xmlHttp = null;
            }
        }
    }
    if (xmlHttp) {
        if (callback != null)
            xmlHttp.onreadystatechange = function() {
                if (xmlHttp.readyState == 4)
                    callback(xmlHttp.responseText.replace(/-nan/g, '0'));
            };
        xmlHttp.open('GET', surl + paramString, true);
        xmlHttp.send(null);
    }
};

dss.raiseEvent = function(name, params) {
    var sURL = '/json/event/raise';
    var paramString = "";
    for ( var key in params) {
        paramString += key + "=" + encodeURIComponent(params[key]) + ";";
    }
    dss.ajaxAssyncRequestWithoutAnswer(sURL, {
        'name' : name,
        'parameter' : paramString.substr(0, paramString.length - 1)
    });
};

dss.getPropertyInteger=function(sProp){
   	var sURL='/json/property/getInteger';
   	var sPfad=escape(sProp);
   	var sReturn=dss.ajaxSyncRequest(sURL,{'path':sPfad});
   	var obj=eval('('+sReturn+')');
   	if (obj.ok)
   		return obj.result.value;
   	else
   		return null;
};


dss.staticDataModel = {};
dss.staticDataModel.baseImagePath = "/framework/images/";
dss.staticDataModel.sQueryStringDevices = "/apartment/zones/zone0/devices/*(*)/*(*)/*(*)";
dss.staticDataModel.sQueryStringStructure = '/apartment/zones/*(ZoneID,name)/groups/*(group,name,color,valid,connectedDevices)/scenes/*(scene,name)';
dss.staticDataModel.sQueryStringHLE = '/usr/events/*(name,id)';
dss.staticDataModel.sQueryStringUSR = '/usr/*/*(name,id,value)/*(*)';
dss.staticDataModel.sQueryStringMeters = '/apartment/dSMeters/*(*)';
dss.staticDataModel.nameCache = null;
dss.staticDataModel.deviceCache = null;
dss.staticDataModel.HLECache = null;
dss.staticDataModel.StateCache = null;
dss.staticDataModel.MeterCache = null;
dss.staticDataModel.activeLanguage="de_DE";
dss.staticDataModel.deviceWithSensorsCache = null;
dss.staticDataModel.deviceAKMCache = null;
dss.staticDataModel.userGroups= null;
dss.staticDataModel.userStates=null;
dss.staticDataModel.stateArray = null;
dss.staticDataModel.heating = null;

dss.staticDataModel.getStateArray = function () {
    if (dss.staticDataModel.stateArray === null) {
        dss.staticDataModel.initStateArray();        
    }
    return dss.staticDataModel.stateArray;
};

dss.staticDataModel.initStateArray = function () {
    var sString = dss.ajaxSyncRequest('/json/property/query2', {
        'query' : '/usr/states/*(*)'
    });
    var result = Ext.JSON.decode(sString);
    if (result.ok) {
        dss.staticDataModel.stateArray = result.result;
    }        
};

dss.staticDataModel.getUsergroups=function () {
	return dss.staticDataModel.userGroups;
};

dss.staticDataModel.getUserStates=function () {
	if (dss.staticDataModel.userStates==null)
		dss.staticDataModel.initUserStateCache();
	return dss.staticDataModel.userStates;
};

dss.staticDataModel.getHLENameFromId = function(id) {
    for ( var iIndex = 0; iIndex < dss.staticDataModel.HLECache.length; iIndex++) {
        if (dss.staticDataModel.HLECache[iIndex].id == id)
            return dss.staticDataModel.HLECache[iIndex].name;
    }
    return id;
};

dss.staticDataModel.refreshDataModel = function() {
	dss.staticDataModel.nameCache = null;
	dss.staticDataModel.deviceCache = null;
	dss.staticDataModel.HLECache = null;
	dss.staticDataModel.StateCache = null;
	dss.staticDataModel.MeterCache = null;
	dss.staticDataModel.deviceWithSensorsCache = null;
	dss.staticDataModel.deviceAKMCache = null;
	dss.staticDataModel.userGroups= null;
	dss.staticDataModel.userStates=null;
	dss.staticDataModel.stateArray = null;
	dss.staticDataModel.initCaches();
	if (Ext!=null)
		if (Ext.data!=null)
			if (Ext.data.StoreManager!=null)
			    Ext.data.StoreManager.clear();
};

dss.staticDataModel.initHeatingCache = function() {
	dss.staticDataModel.heating={};
	dss.staticDataModel.heating[0]={};
	dss.staticDataModel.heating[0].configured=true;
	dss.staticDataModel.heating[0].active=true;
	dss.staticDataModel.heating[0].receiveOperationMode=true;
	
	var sString = dss.ajaxSyncRequest('/json/apartment/getTemperatureControlConfig', {});
	var result = Ext.JSON.decode(sString);
	if (result.ok) {
		for (var iIndex=0;iIndex<result.result.zones.length;iIndex++) {
			var zoneNode=result.result.zones[iIndex];
			dss.staticDataModel.heating[zoneNode.id]={configured:zoneNode.IsConfigured};
			if (zoneNode.IsConfigured) {
				if (zoneNode.ControlMode==0)
					dss.staticDataModel.heating[zoneNode.id].active=false;
				else
					dss.staticDataModel.heating[zoneNode.id].active=true;
				if ((zoneNode.ControlMode==1) || (zoneNode.ControlMode==3))
					dss.staticDataModel.heating[zoneNode.id].receiveOperationMode=true;
				else
					dss.staticDataModel.heating[zoneNode.id].receiveOperationMode=false;
			}
			else {
				dss.staticDataModel.heating[zoneNode.id].active=false;
				dss.staticDataModel.heating[zoneNode.id].receiveOperationMode=false;
			}
		}
	}
};

dss.staticDataModel.initCaches = function() {
    dss.staticDataModel.initNameCache();
    dss.staticDataModel.initSpecialActions();
    dss.staticDataModel.initDeviceCache();
    dss.staticDataModel.initHLECache();
    dss.staticDataModel.initMeterCache();
    dss.staticDataModel.initSunriseTimes();
    dss.staticDataModel.initUserStateCache();
    dss.staticDataModel.initStateArray();
    dss.staticDataModel.getDSSTime();
    dss.staticDataModel.initHeatingCache();
    dss.staticDataModel.initZoneSensorCache();
};

dss.staticDataModel.localizeName=function(nameObject) {
	var sName="";
	if (nameObject[dss.staticDataModel.activeLanguage]!=null)
		sName=nameObject[dss.staticDataModel.activeLanguage];
	else
		if (nameObject['en_US']!=null)
			sName=nameObject['en_US'];
		else
			if (nameObject['de_DE']!=null)
    			sName=nameObject['de_DE'];
	return dss.unescapeProperty(sName);
}

dss.staticDataModel.initSpecialActions = function() {
	var sResult = dss.ajaxSyncRequest('/json/property/query2', {
		'query' : '/scripts/system-addon-scene-responder/specialDevices/*(*)/*(*)/*(*)/*(*)/*(*)'
	});
	var resultObj = Ext.JSON.decode(sResult);
	if (resultObj.ok) {
		dss.staticDataModel.specialAction = resultObj.result;
		
		for (var sZoneKey in dss.staticDataModel.specialAction) {
			if (dss.staticDataModel.specialAction[sZoneKey].actions!=null) {
				for (var sActionType in dss.staticDataModel.specialAction[sZoneKey].actions) {
					for (var sActionIndex in dss.staticDataModel.specialAction[sZoneKey].actions[sActionType]) {
						dss.staticDataModel.specialAction[sZoneKey].actions[sActionType][sActionIndex].name=
							dss.staticDataModel.localizeName(dss.staticDataModel.specialAction[sZoneKey].actions[sActionType][sActionIndex].name);
					}
					
				}
			}
			if (dss.staticDataModel.specialAction[sZoneKey].triggers!=null) {
				for (var sActionType in dss.staticDataModel.specialAction[sZoneKey].triggers) {
					for (var sActionIndex in dss.staticDataModel.specialAction[sZoneKey].triggers[sActionType]) {
						dss.staticDataModel.specialAction[sZoneKey].triggers[sActionType][sActionIndex].name=
							dss.staticDataModel.localizeName(dss.staticDataModel.specialAction[sZoneKey].triggers[sActionType][sActionIndex].name);
					}
					
				}
			}
		}
	}	  
};

dss.staticDataModel.initUserStateCache = function () {
	var sString = dss.ajaxSyncRequest('/json/property/query', {
        'query' : '/scripts/user-defined-states/entries/*(*)'
    });
    var result = Ext.JSON.decode(sString);
    if (result.ok) {
    	dss.staticDataModel.userStates= dss.parsePropertyQueryAnswer(result,[{name:'name',type:'simple'},
                                                           {name:'id',type:'simple'}]);
    }
};

dss.staticDataModel.initMeterCache = function() {
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringMeters
    });
    var resultObj = Ext.JSON.decode(sResult);
    if (resultObj.ok) {
        if (resultObj.result.dSMeters != null) {
            dss.staticDataModel.MeterCache = resultObj.result.dSMeters;
        }
    }
};

dss.staticDataModel.getMeter = function(dSUID) {
    var tempdSUID;
	if (dss.staticDataModel.MeterCache === null)
		dss.staticDataModel.initCaches();
    if (DSS.types.dsuid.isDSUID(dSUID)) {
        for (var iIndex=0;iIndex<dss.staticDataModel.MeterCache.length;iIndex++) {
            if (dss.staticDataModel.MeterCache[iIndex].dSUID && (dss.staticDataModel.MeterCache[iIndex].dSUID === dSUID)) {
                return dss.staticDataModel.MeterCache[iIndex];
            } else {
                if (dss.staticDataModel.MeterCache[iIndex].dSID) {
                    var tempdSUID = DSS.types.dsuid.dsid_to_dsuid(dss.staticDataModel.MeterCache[iIndex].dSID);
                    if (tempdSUID === dSUID) {
                        return dss.staticDataModel.MeterCache[iIndex];
                    }
                }
            }
        }
    } else {
        //we still got a dSID so lets try whether we find a matching 
        for (var iIndex=0;iIndex<dss.staticDataModel.MeterCache.length;iIndex++) {
            if (dss.staticDataModel.MeterCache[iIndex].dSID && (dss.staticDataModel.MeterCache[iIndex].dSID === dSUID)) {
                return dss.staticDataModel.MeterCache[iIndex];
            } else {
                if (dss.staticDataModel.MeterCache[iIndex].dSUID) {
                    tempdSUID = DSS.types.dsuid.dsid_to_dsuid(dSUID);
                    if (dss.staticDataModel.MeterCache[iIndex].dSUID === tempdSUID) {
                        return dss.staticDataModel.MeterCache[iIndex];
                    }
                }
            }
        }        
    }
	return null;
};

dss.staticDataModel.getMeterName = function(MeterDSUID){
    if (dss.staticDataModel.MeterCache == null)
        dss.staticDataModel.initCaches();
    var baseName = Ext.String.format2(_('Meter dSUID {dsuid}'), {dsuid:DSS.types.dsuid.shortdSUID(MeterDSUID)});
   
	for (var iIndex=0;iIndex<dss.staticDataModel.MeterCache.length;iIndex++)
		if (dss.staticDataModel.MeterCache[iIndex].dSUID==MeterDSUID)
			if (dss.staticDataModel.MeterCache[iIndex].name!="")
                return dss.staticDataModel.MeterCache[iIndex].name;
    return baseName;
};

dss.staticDataModel.getImagePathForState = function(stateName,stateValue) {
	if (stateName==null)
		return "";
	switch (stateName.split('.')[0]) {
		case 'rain':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/rain.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/rain_No.png';
			break;
			
		case 'wind':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/wind.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/wind_No.png';
			break;

		case 'hail':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/hail.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/hail_No.png';
			break;	

		case 'panic':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/panic.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/panic_No.png';
			break;	
			
		case 'fire':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/fire.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/fire_No.png';
			break;			
			
		case 'alarm':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/alarm.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/alarm_No.png';
			break;			
			
		case 'alarm2':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/alarm2.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/alarm2_No.png';
			break;			
			
		case 'alarm3':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/alarm3.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/alarm3_No.png';
			break;			
			
		case 'alarm4':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/alarm4.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/alarm4_No.png';
			break;

		case 'holiday':
			if ((stateValue=='active') || (stateValue=='1') || (stateValue=='on'))
				return dss.staticDataModel.baseImagePath+'state/simulation_on.png';
			if ((stateValue=='inactive') || (stateValue=='2') || (stateValue=='off'))
				return dss.staticDataModel.baseImagePath+'state/simulation_off.png';
			break;
		
		case 'daylight':
			if ((stateValue=='active') || (stateValue=='1') || (stateValue==true))
				return dss.staticDataModel.baseImagePath+'state/daylight_true.png';
			if ((stateValue=='inactive') || (stateValue=='2') || (stateValue==false))
				return dss.staticDataModel.baseImagePath+'state/daylight_false.png';
			break;
		
		case 'daynight':
			if ((stateValue=='active') || (stateValue=='1') || (stateValue==true))
				return dss.staticDataModel.baseImagePath+'state/daynight_true.png';
			if ((stateValue=='inactive') || (stateValue=='2') || (stateValue==false))
				return dss.staticDataModel.baseImagePath+'state/daynight_false.png';
			break;

		case 'presence':
			if ((stateValue=='active') || (stateValue=='1') || (stateValue=='present'))
				return dss.staticDataModel.baseImagePath+'state/present.png';
			if ((stateValue=='inactive') || (stateValue=='2') || (stateValue=='absent'))
				return dss.staticDataModel.baseImagePath+'state/present_No.png';
			break;	

		case 'frost':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/frost.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/frost_no.png';
			break;

		case 'sun':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/sun.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/sun_no.png';
			break;

		case 'heating_mode':
			if (stateValue=='off')
				return dss.staticDataModel.baseImagePath+'state/heating_mode_off.png';
			if (stateValue=='heating')
				return dss.staticDataModel.baseImagePath+'state/heating_mode_heating.png';
			if (stateValue=='cooling')
				return dss.staticDataModel.baseImagePath+'state/heating_mode_cooling.png';
			if (stateValue=='auto')
				return dss.staticDataModel.baseImagePath+'state/heating_mode_auto.png';
			break;

		case 'service':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/service.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/service_no.png';
			break;

		case 'operation_lock':
			if ((stateValue=='active') || (stateValue=='1'))
				return dss.staticDataModel.baseImagePath+'state/operation_lock.png';
			if ((stateValue=='inactive') || (stateValue=='2'))
				return dss.staticDataModel.baseImagePath+'state/operation_lock_no.png';
			break;
			
	}	
	return null;
}; 

dss.staticDataModel.getImagePathForConditionState = function(ConditionActive) {
    var imagePath = '';
    if (ConditionActive) {
        imagePath = dss.staticDataModel.baseImagePath + 'dss/bedingung_aktiv.png';
    } else {
        imagePath = dss.staticDataModel.baseImagePath + 'dss/bedingung_inaktiv.png';
    }
    return imagePath;
};

dss.staticDataModel.getNameForState = function(stateName,stateValue) {
	switch (stateName) {
		case 'rain':
			if (stateValue=='active')
				return _('rain active');
			if (stateValue=='inactive')
				return _('rain inactive');
			break;
			
		case 'wind':
			if (stateValue=='active')
				return _('wind active');
			if (stateValue=='inactive')
				return _('wind inactive');
			break;
			
		case 'hail':
			if (stateValue=='active')
				return _('hail active');
			if (stateValue=='inactive')
				return _('hail inactive');
			break;
			
		case 'fire':
			if (stateValue=='active')
				return _('fire active');
			if (stateValue=='inactive')
				return _('fire inactive');
			break;

		case 'frost':
			if (stateValue=='active')
				return _('frost active');
			if (stateValue=='inactive')
				return _('frost inactive');
			break;

		case 'sun':
			if (stateValue=='active')
				return _('sun active');
			if (stateValue=='inactive')
				return _('sun inactive');
			break;

		case 'heating_mode':
			if (stateValue=='off')
				return _('heating mode off');
			if (stateValue=='heating')
				return _('heating mode heating');
			if (stateValue=='cooling')
				return _('heating mode cooling');
			if (stateValue=='auto')
				return _('heating mode auto');
			break;

		case 'service':
			if (stateValue=='active')
				return _('service active');
			if (stateValue=='inactive')
				return _('service inactive');
			break;
	}	
	return _(stateName+'_'+stateValue);
};

dss.staticDataModel.getSunrise= function() {
	if (dss.staticDataModel.nowSunrise==null)
		dss.staticDataModel.initSunriseTimes(); 
	return dss.staticDataModel.nowSunrise;
};

dss.staticDataModel.getSunset= function() {
	if (dss.staticDataModel.nowSunset==null)
		dss.staticDataModel.initSunriseTimes(); 
	return dss.staticDataModel.nowSunset;
};

dss.staticDataModel.getDawn= function() {
	if (dss.staticDataModel.nowDawn==null)
		dss.staticDataModel.initSunriseTimes(); 
	return dss.staticDataModel.nowDawn;
};

dss.staticDataModel.getDusk= function	() {
	if (dss.staticDataModel.nowDusk==null)
		dss.staticDataModel.initSunriseTimes(); 
	return dss.staticDataModel.nowDusk;
};


dss.staticDataModel.deltaTime=null;

dss.staticDataModel.getDSSTime=function() {
    var dReference = new Date(); //10:00
    if (dss.staticDataModel.deltaTime==null) {
    	var sResult = dss.ajaxSyncRequest('/json/property/query2',{query:'/system/time(current_sec,gmt_offset)'});
        var result = Ext.JSON.decode(sResult);
        if (result.ok) {
        	if (result.result.time!=null) {
	        	dss.staticDataModel.deltaTime=dReference.getTime() - (result.result.time.current_sec*1000); // -1:00
	        	var oBrowserOffset=dReference.getTimezoneOffset()*60*1000;
	        	var oDSSOffset=result.result.time.gmt_offset*1000;
	        	dss.staticDataModel.deltaTime-=(oDSSOffset+oBrowserOffset);
        	} else {
	        	var sResponseText =	dss.ajaxSyncRequest('/cgi-bin/dateinfo.sh', {});
	    		if (sResponseText.substring(0, 9) == "Error 404") {
	    			dss.staticDataModel.deltaTime=0;
	    		} else {
	    	        var resultObj = Ext.JSON.decode(sResponseText);
	    	        if (resultObj.success) {               //10:00                      //11:00
	    	        	dss.staticDataModel.deltaTime=dReference.getTime() - (resultObj.data.utcsecs*1000); // -1:00
	    	        	var oBrowserOffset=dReference.getTimezoneOffset()*60*1000;
	    	        	var oDSSOffset=resultObj.data.gmtoffset*60*60*1000;
	    	        	dss.staticDataModel.deltaTime-=(oDSSOffset+oBrowserOffset);
	    	        }
	    	    }        		
        	}
        }    	
	    dReference = new Date();
	    
    }                       //10:00               //-1:00             
    return new Date(dReference.getTime() - dss.staticDataModel.deltaTime); //11:00
};


dss.staticDataModel.initSunriseTimeAsync = function () {
    dss.ajaxAssyncRequestWithoutAnswer('/json/property/query2',{query:'/config/geodata(sunset,sunrise,civil_dawn,civil_dusk)'},function(sString){
        var result = Ext.JSON.decode(sString);
        if (result.ok) {
        	dss.staticDataModel.nowDawn=result.result.geodata.civil_dawn;
        	dss.staticDataModel.nowDusk=result.result.geodata.civil_dusk;
        	dss.staticDataModel.nowSunrise=result.result.geodata.sunrise;
            dss.staticDataModel.nowSunset=result.result.geodata.sunset;
        }
    });
};

dss.staticDataModel.initSunriseTimes = function () {
    var sResult = dss.ajaxSyncRequest('/json/property/query2', {
        'query' : '/config/geodata(sunset,sunrise,civil_dawn,civil_dusk)'
    });   
    var result = Ext.JSON.decode(sResult);
    if (result.ok) {
    	dss.staticDataModel.nowDawn=result.result.geodata.civil_dawn;
    	dss.staticDataModel.nowDusk=result.result.geodata.civil_dusk;
    	dss.staticDataModel.nowSunrise=result.result.geodata.sunrise;
        dss.staticDataModel.nowSunset=result.result.geodata.sunset;
    }
};

/**
 * Returns the distroVersion of the dSS. If not yet stored it will be read from the property tree.
 * @return distroVersionString
 */
dss.staticDataModel.getdSSVersion = function() {
    if (dss.staticDataModel.dSSVersion == null){
        var sResult = dss.ajaxSyncRequest('/json/property/query2', {
            'query' : '/system/version(distroVersion)'
        });   
        var result = Ext.JSON.decode(sResult);
        if (result.ok && (result.result.version !== undefined)) {
            dss.staticDataModel.dSSVersion =result.result.version.distroVersion;
        } else {
            dss.staticDataModel.dSSVersion='unknown';
        }
    }
    return  dss.staticDataModel.dSSVersion;
};

/**
 * Returns the distroVersion of the dSS. If not yet stored it will be read from the property tree.
 * @return distroVersionString
 */
dss.staticDataModel.getdSSFeed = function() {
    if (dss.staticDataModel.dSSFeed == null){
        var sResult = dss.ajaxSyncRequest('/json/property/query2', {
            'query' : '/system/version(releasetype)'
        });   
        var result = Ext.JSON.decode(sResult);
        if (result.ok && (result.result.version !== undefined)) {
            dss.staticDataModel.dSSFeed =result.result.version.releasetype;
        } else {
            dss.staticDataModel.dSSFeed='unknown';
        }
    }
    return  dss.staticDataModel.dSSFeed;
};

dss.staticDataModel.initNameCache = function() {
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringStructure
    });
    var resultObj = Ext.JSON.decode(sResult);
    if (resultObj.ok) {
        if (resultObj.result.zones != null) {
            dss.staticDataModel.nameCache = resultObj.result.zones;            
        }
    }
};

dss.staticDataModel.initDeviceCache = function() {
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringDevices
    });
    var resultObj = Ext.JSON.decode(sResult);
    if (resultObj.ok) {
        dss.staticDataModel.deviceCache = [];
        dss.staticDataModel.deviceWithSensorsCache = [];
        dss.staticDataModel.deviceAKMCache = [];
        if (resultObj.result.devices!=null) {
            for ( var iIndex = 0; iIndex < resultObj.result.devices.length; iIndex++) {
                var oDevObject = resultObj.result.devices[iIndex];
                
                var newObject = {
                    dSID : oDevObject.dSID,
                    dSUID : oDevObject.dSUID,
                    name : oDevObject.name,
                    present : oDevObject.present,
                    functionID : oDevObject.functionID,
                    productID : oDevObject.productID,
                    outputMode : oDevObject.outputMode,
                    ZoneID : oDevObject.ZoneID,
                    DSMeterDSID : oDevObject.DSMeterDSID,
                    DSMeterDSUID : oDevObject.DSMeterDSUID,
                    HWInfo : oDevObject.HWInfo,
                    DisplayID: oDevObject.DisplayID,
                    GroupMembership : [],
                    sensors : [],
                    specialActions : {}
                };

                var subObject = oDevObject[oDevObject.dSUID];
                for ( var jIndex = 0; jIndex < subObject.length; jIndex++) {
                	if (subObject[jIndex].binaryInputs != null)  {
                		 newObject.binaryInputs=[];
                    	for (var kIndex=0;kIndex<subObject[jIndex].binaryInputs.length;kIndex++) {
                            newObject.binaryInputs.push({type:subObject[jIndex].binaryInputs[kIndex].inputType,index:subObject[jIndex].binaryInputs[kIndex].inputIndex});
                    	}
                	}
                    if (subObject[jIndex].sensorEvents != null) {
                        newObject.sensorEvents = [];
                        for ( var sKey in subObject[jIndex]) {
                            if (sKey != 'sensorEvents')
                                newObject.sensorEvents.push({name:subObject[jIndex][sKey],id:sKey});
                        }
                    }
                        	                                                                       	
                    if (subObject[jIndex].sensorInputs!=null) {
                    	for (var sIndex=0;sIndex<subObject[jIndex].sensorInputs.length;sIndex++) {
                    		newObject.sensors.push({type:subObject[jIndex].sensorInputs[sIndex].type});
                    	}
                    }
                    
                    if (subObject[jIndex].EAN!=null) {
                        if (dss.staticDataModel.specialAction[subObject[jIndex].EAN]!=null)
                        	newObject.specialActions=dss.staticDataModel.specialAction[subObject[jIndex].EAN];
                        else
                            if (dss.staticDataModel.specialAction[resultObj.result.devices[iIndex].functionID]!=null)
                            	newObject.specialActions=dss.staticDataModel.specialAction[resultObj.result.devices[iIndex].functionID];
                    }
                    
                    if (subObject[jIndex].button != null) {
                        if (subObject[jIndex].id != null)
                            newObject.tasterMode = subObject[jIndex].id;
                        if (subObject[jIndex].groupMembership != null)
                            newObject.buttonGroupMembership = subObject[jIndex].groupMembership;
                        if (subObject[jIndex].activeGroup != null)
                            newObject.buttonActiveGroup = subObject[jIndex].activeGroup;
                        if (subObject[jIndex].setsLocalPriority != null)
                            newObject.buttonSetsLocalPriority = subObject[jIndex].setsLocalPriority;
                        if (subObject[jIndex].inputMode != null)
                            newObject.buttonType = subObject[jIndex].inputMode;
                        if (newObject.buttonActiveGroup==255)
                        	newObject.buttonActiveGroup=8;
                    }
                    if (subObject[jIndex].groups != null) {
                        for ( var kIndex = 0; kIndex < subObject[jIndex].groups.length; kIndex++) {
                        	newObject.GroupMembership.push(subObject[jIndex].groups[kIndex].id);
                            if (subObject[jIndex].groups[kIndex].id != 8) // 8 kann nicht ausf�hrungsgruppe sein
                                if (subObject[jIndex].groups[kIndex].id < 16) // nur in den basisgruppen bleiben
                                	newObject.GroupID = subObject[jIndex].groups[kIndex].id;  // base color Group
                        }
                        if (newObject.GroupID==null)
                        	if (newObject.GroupMembership.length==1)
                        		newObject.GroupID=newObject.GroupMembership[0];
                    }
                }
                
                if (newObject.specialActions.triggers!=null)
                    if (newObject.specialActions.triggers['deviceEvents']!=null) {
                    	if ( newObject.sensorEvents==null)
                            newObject.sensorEvents = [];
                    	for (var sKey in newObject.specialActions.triggers['deviceEvents']) {
                    		var oObject=newObject.specialActions.triggers['deviceEvents'][sKey];                   		
                    		newObject.sensorEvents.push({name:oObject.name,id:oObject.id});
                    	}
                    }

                
                if (newObject.name == "")
                    newObject.name = "(" + newObject.DisplayID + ")";
                newObject.icon = dss.staticDataModel.getImageForDevice(newObject);
                dss.staticDataModel.deviceCache.push(newObject);
                if (newObject.sensorEvents != null)
                    if (newObject.sensorEvents.length > 0)
                        dss.staticDataModel.deviceWithSensorsCache.push(newObject);
                if (newObject.binaryInputs != null)
                    if (newObject.binaryInputs.length > 0) {
                        //at the moment only AKMs are handled, tiny is implemented in ds-trigger-selector.js
                        //but it should first be tested with a real device and reviewed with PO
                    	// roman: anyway: ANYTHING which makes a dev.<dsuid>.0 state in the property must be handled a a AKM! regardless of a product ID ... when a tiny make such a entry,
                    	// it IS A AKM or the tiny is wrong!
                        if (dss.staticDataModel.hasDeviceStates(newObject.dSUID) && (newObject.buttonType >= 16)) {
                            dss.staticDataModel.deviceAKMCache.push(newObject);
                        }
                    }
            }
        }
    }
    var zone0Index = -1;
    var groupToAdd = [];
    for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        var oZone = dss.staticDataModel.nameCache[iIndex];
        if (oZone.ZoneID === 0) {
            zone0Index = iIndex;
        }
        if (oZone.name == "") {
            if (oZone.ZoneID == 0)
                oZone.name = _('All rooms');
            else
                oZone.name = Ext.String.format2(_("Room ID {zone}"),{zone:oZone.ZoneID});
        }
        for ( var jIndex = 0; jIndex < oZone.groups.length; jIndex++) {
            var oGroup = oZone.groups[jIndex];
            oGroup.icon = dss.staticDataModel.getImagePathForGroup(oZone.ZoneID, oGroup.group);
            oGroup.name = dss.staticDataModel.getNameForGroup(oZone.ZoneID, oGroup.group);
            oGroup.reachable = false;
            if (oGroup.group == 0)
                oGroup.reachable = true;
            if (0 < oGroup.connectedDevices) {
                oGroup.reachable = true;
                if (-1 === groupToAdd.indexOf(oGroup.group)) {
                    groupToAdd.push(oGroup.group);
                }
            }
            for ( var iDeviceIndex = 0; iDeviceIndex < dss.staticDataModel.deviceCache.length; iDeviceIndex++)
                if ((dss.staticDataModel.deviceCache[iDeviceIndex].ZoneID == oZone.ZoneID) || (oZone.ZoneID == 0))
                	if (dss.staticDataModel.deviceCache[iDeviceIndex].GroupMembership!=null)
	                	for (var iDeviceGroupIndex=0;iDeviceGroupIndex<dss.staticDataModel.deviceCache[iDeviceIndex].GroupMembership.length;iDeviceGroupIndex++)
	                		if (dss.staticDataModel.deviceCache[iDeviceIndex].GroupMembership[iDeviceGroupIndex] == oGroup.group)
	                			oGroup.reachable = true;
            dss.staticDataModel.nameCache[iIndex].groups[jIndex]=oGroup;
        }                       
    }
    if (groupToAdd.length > 0) {
        oZone = dss.staticDataModel.nameCache[zone0Index];
        for ( var jIndex = 0; jIndex < oZone.groups.length; jIndex++) {
            var oGroup = oZone.groups[jIndex]; 
            if (-1 !== groupToAdd.indexOf(oGroup.group)) { 
                oGroup.icon = dss.staticDataModel.getImagePathForGroup(oZone.ZoneID, oGroup.group);
                oGroup.name = dss.staticDataModel.getNameForGroup(oZone.ZoneID, oGroup.group);
                oGroup.reachable = true;
                dss.staticDataModel.nameCache[zone0Index].groups[jIndex]=oGroup;
            }
        }
    }
    
    dss.staticDataModel.userGroups =[];
    for (var iIndex=0;iIndex<dss.staticDataModel.nameCache.length;iIndex++) {
    	if (dss.staticDataModel.nameCache[iIndex].ZoneID==0) {
    		for (var jIndex=0;jIndex<dss.staticDataModel.nameCache[iIndex].groups.length;jIndex++) {
                if (dss.staticDataModel.isClusterGroup(dss.staticDataModel.nameCache[iIndex].groups[jIndex].group))
                    if (dss.staticDataModel.nameCache[iIndex].groups[jIndex].color !== 0) {
                        dss.staticDataModel.userGroups.push({
                            id:dss.staticDataModel.nameCache[iIndex].groups[jIndex].group,
                            name:dss.staticDataModel.nameCache[iIndex].groups[jIndex].name,
                            reachable:dss.staticDataModel.nameCache[iIndex].groups[jIndex].reachable,
                            color:dss.staticDataModel.nameCache[iIndex].groups[jIndex].color});
                    }
    		}
    	}
    }
};

dss.staticDataModel.initZoneSensorCache = function() {
	// json/property/query2?query=/apartment/zones/*(ZoneID)/groups/group0/sensor/*(*)
};


dss.staticDataModel.hasDeviceStates = function (dsuid) {
	var states=dss.staticDataModel.getStates();
	for (var iIndex=0;iIndex<states.length;iIndex++) {
		var oState=states[iIndex];
		if (oState.name.indexOf(dsuid)!=-1)
			return true;
	}
	return false;	
};

dss.staticDataModel.initHLECache = function() {
    dss.staticDataModel.HLECache = [];
    dss.staticDataModel.StateCache = [];
    
    var sResult = dss.ajaxSyncRequest('/json/property/query', {
        'query' : dss.staticDataModel.sQueryStringUSR
    });
    var resultObj = Ext.JSON.decode(sResult);
    if (resultObj.ok) {
        if (resultObj.result.events != null) {
            for (var iIndex=0;iIndex<resultObj.result.events.length;iIndex++) {
                var oObject={   name: resultObj.result.events[iIndex].name,
                                id: resultObj.result.events[iIndex].id};
                dss.staticDataModel.HLECache.push(oObject);
            }
        }
        if (resultObj.result.states != null) {
            for (var iIndex=0;iIndex<resultObj.result.states.length;iIndex++) {
                var oObjectState={  name: resultObj.result.states[iIndex].name,
                                    value: resultObj.result.states[iIndex].value,
                                    valuerange:[]};
                for (var sKey in resultObj.result.states[iIndex]) {
                    if (sKey!='name')
                        if (sKey!='value') {
                            for (var jIndex=0;jIndex<resultObj.result.states[iIndex][sKey].length;jIndex++)
                                for (var sSubKey in resultObj.result.states[iIndex][sKey][jIndex]) {
                                    var oValue={name:sSubKey,value: resultObj.result.states[iIndex][sKey][jIndex][sSubKey]};
                                    oObjectState.valuerange.push(oValue);
                                }
                        }
                } 
                if (oObjectState.valuerange.length==0) { 
                    oObjectState.valuerange.push({name:'true',value:true});
                    oObjectState.valuerange.push({name:'false',value:false});
                }
                dss.staticDataModel.StateCache.push(oObjectState);
            }
            
        }        
    }
};

dss.staticDataModel.getHLE = function() {
    if (dss.staticDataModel.HLECache == null)
        dss.staticDataModel.initHLECache();
    return dss.staticDataModel.HLECache;
};

dss.staticDataModel.getStates = function() {
    if (dss.staticDataModel.StateCache == null)
        dss.staticDataModel.initHLECache();
    
    var oResult = [];
    for ( var iIndex = 0; iIndex < dss.staticDataModel.StateCache.length; iIndex++) {
        var valuerange=[];
        for (var jIndex=0;jIndex < dss.staticDataModel.StateCache[iIndex].valuerange.length;jIndex++) {
            valuerange.push({  name:dss.staticDataModel.StateCache[iIndex].valuerange[jIndex].name,
                              value:dss.staticDataModel.StateCache[iIndex].valuerange[jIndex].value});
        }
        oResult.push({
            value : dss.staticDataModel.StateCache[iIndex].value,
            name : dss.staticDataModel.StateCache[iIndex].name,
            valuerange:valuerange
        });
    }
    return oResult;
};

dss.staticDataModel.getSensorDeviceArray = function() {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return dss.staticDataModel.deviceWithSensorsCache;
};

dss.staticDataModel.getAKMDeviceArray = function() {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return dss.staticDataModel.deviceAKMCache;	
};

dss.staticDataModel.getZoneArray = function() {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();

    var oResult = [];
    for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache.length; iIndex++) {
        oResult.push({
            ZoneID : dss.staticDataModel.nameCache[iIndex].ZoneID,
            name : dss.staticDataModel.nameCache[iIndex].name
        });
    }
    return oResult;
};

dss.staticDataModel.getDevicesForZone = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var oRetArray = [];
    for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
        var oDeviceObject = dss.staticDataModel.deviceCache[i];
        var fAdded=false;
        for (var j=0;j<oDeviceObject.GroupMembership.length;j++) {
	        var oDeviceGroup=oDeviceObject.GroupMembership[j];
	        if (oDeviceGroup==8)
	            oDeviceGroup=oDeviceObject.buttonActiveGroup;
	        if ((oDeviceObject.ZoneID == zoneID) || (zoneID == 0))
	            if ((oDeviceGroup == groupID) || (groupID == 0)) 
	            	if (!fAdded) {
	            		oRetArray.push(oDeviceObject);
	            		fAdded=true;
	            	}
        }
    }
    return oRetArray;
};
dss.staticDataModel.getNameForSensorEvent = function (device,eventid) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    if (device==null)
        return "";
    if (device.sensorEvents==null)
        return "";
    for (var iIndex=0;iIndex<device.sensorEvents.length;iIndex++) {
        if (device.sensorEvents[iIndex].id==eventid)
            return device.sensorEvents[iIndex].name;
    }
    return "";
};

dss.staticDataModel.getImageForAKMValue = function (type,value) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
            
    return '<img src="' + dss.staticDataModel.getImagePathForAKMValue (type,value) + '" alt="'
            + dss.staticDataModel.getNameForAKMValue(type,value) + '">';
};

dss.staticDataModel.getImagePathForAKMValue = function (type,value) {
	// aktuell device == akm

	switch (type) {
		case 7:
			if (value) 
				return dss.staticDataModel.baseImagePath + 'state/fire.png';
			else
				return dss.staticDataModel.baseImagePath + 'state/fire_No.png';
			break;
		case 8:
			if (value) 
				return dss.staticDataModel.baseImagePath + 'state/wind.png';
			else
				return dss.staticDataModel.baseImagePath + 'state/wind_No.png';
			break;
		case 9:
			if (value) 
				return dss.staticDataModel.baseImagePath + 'state/rain.png';
			else
				return dss.staticDataModel.baseImagePath + 'state/rain_No.png';
			break;
		case 13: //window open
			if (value) 
				return dss.staticDataModel.baseImagePath + 'state/window-open.png';
			else
				return dss.staticDataModel.baseImagePath + 'state/window-closed.png';
			break;
		case 14: //door open
			if (value) 
				return dss.staticDataModel.baseImagePath + 'state/door-open.png';
			else
				return dss.staticDataModel.baseImagePath + 'state/door-closed.png';
			break;
		case 15: //window tilted
			if (value) 
				return dss.staticDataModel.baseImagePath + 'state/window-tilted.png';
			else
				return dss.staticDataModel.baseImagePath + 'state/window-open.png';
			break;
		default:
			if (value) 
				return dss.staticDataModel.baseImagePath + 'state/sensor.png';
			else
				return dss.staticDataModel.baseImagePath + 'state/sensor_No.png';
			break;
	}	
	return dss.staticDataModel.baseImagePath + 't.gif';
};

dss.staticDataModel.getNameForAKMValue = function (type,value) {
	// aktuell device == akm
	switch (type) {
	case 0:
		if (value) 
			return _('Contact closed');
		else
			return _('Contact open');
		break;
	case 1:
		if (value) 
			return _('Contact closed');
		else
			return _('Contact open');
		break;
	case 2:
		if (value) 
			return _('Present');
		else
			return _('Absent');
		break;
	case 3:
		if (value) 
			return _('bright');
		else
			return _('dark');
		break;
	case 4:
		if (value) 
			return _('dark');
		else
			return _('bright');
		break;
	case 5:
		if (value) 
			return _('Motion detected');
		else
			return _('no Motion');
		break;
	case 6:
		if (value) 
			return _('Motion detected');
		else
			return _('no Motion');
		break;
	case 7:
		if (value) 
			return _('Smoke detected');
		else
			return _('no Smoke');
		break;
	case 8:
		if (value) 
			return _('Wind');
		else
			return _('no Wind');
		break;
	case 9:
		if (value) 
			return _('Rain detected');
		else
			return _('no Rain');
		break;
	case 10:
		if (value) 
			return _('bright');
		else
			return _('dark');
		break;
	case 11:
		if (value) 
			return _('temperature low');
		else
			return _('temperature high');
		break;
	case 13:
		if (value) 
			return _('window open');
		else
			return _('window closed');
		break;
	case 14:
		if (value) 
			return _('door open');
		else
			return _('door closed');
		break;
	case 15:
		if (value) 
			return _('window tilted open');
		else
			return _('window fully opened');
		break;
	case 255:
		if (value) 
			return _('Contact closed');
		else
			return _('Contact open');
		break;
	default:
		if (value) 
			return _('Contact closed');
		else
			return _('Contact open');
		break;
		
	}	
};

dss.staticDataModel.getNameForAKMType = function (type) {
	// aktuell device == akm
	switch (type) {
		case 0:
			return _('Generic (App)');
			break;
		case 1:
			return _('Presence');
			break;
		case 2:
			return _('Brightness (Room)');
			break;
		case 3:
			return _('Presence in darkness');
			break;
		case 4:
			return _('Twilight (outdoors)');
			break;
		case 5:
			return _('Movement');
			break;
		case 6:
			return _('Movement in darkness');
			break;
		case 7:
			return _('Smoke detector');
			break;
		case 8:
			return _('Wind monitor');
			break;
		case 9:
			return _('Rain monitor');
			break;
		case 10:
			return _('Sunlight');
			break;
		case 11:
			return _('Room thermostat');
			break;
        case 13: 
            return _('window contact');
            break;
        case 14:
            return _('door contact');
            break;
        case 15:
            return _('window  handle');
            break;
		case 255:
			return _('Reserved');
			break;
		default:
			return _('Generic (App)');
			break;
	}
};

dss.staticDataModel.getNameForGroup = function(zoneID, group) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var defaultName = Ext.String.format2(_("Group {group} "),{group:group});
    var baseName = "";
    var baseName2 ="XXXXXXXXXXX";

    switch (group) {
        case 0:
            defaultName = 'Alle Gruppen';
            baseName = 'broadcast';
            baseName2 = 'broadcast';
        break;
        case 1:
            defaultName = _('Light');
            baseName = 'yellow';
            baseName2 = 'yellow';
        break;
        case 2:
            defaultName = _('Shadow');
            baseName = 'gray';
            baseName2 = 'gray';
        break;
        case 3:
            defaultName = _('Climate');
            baseName = 'blue';
            baseName2 = 'heating';
        break;
        case 4:
            defaultName = _('Audio');
            baseName = 'cyan';
            baseName2 = 'cyan';
        break;
        case 5:
            defaultName = _('Video');
            baseName = 'magenta';
            baseName2 = 'magenta';
        break;
        case 6:
            defaultName = _('Security');
            baseName = 'red';
            baseName2 = 'reserved1';
        break;
        case 7:
            defaultName = _('Access');
            baseName = 'green';
            baseName2 = 'reserved2';
        break;
        case 8:
            defaultName = _('Joker');
            baseName = 'black';
            baseName2 = 'black';
        break;
        case 9:
            defaultName = _('cooling');
            baseName = 'white';
            baseName2 = 'cooling';
        break;
        case 10:
            defaultName = _('ventilation');
            baseName = 'display';
            baseName2 = 'ventilation';
        break;
        case 11:
            defaultName = _('window');
            baseName = 'display';
            baseName2 = 'window';
        break;
        case 48:
            defaultName = _('heating');
            baseName = 'heating';
            baseName2 = 'heating';
        break;
    }

    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            for ( var iGroupIndex = 0; iGroupIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iGroupIndex++)
                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].group == group)
                    if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name && (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name != baseName))
                        if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name && (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name != baseName2))
                        	return dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].name;
    return defaultName;
};

dss.staticDataModel.getDefaultNameForScene = function(zoneID, group, scene) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    if (zoneID==0)
	    if (dss.staticDataModel.isClusterGroup(group)) {
	    	group=dss.staticDataModel.getUserGroupColor(group);
	    }
    
    var defaultName = _("Scene ") + scene;

    switch (scene) {
        case 67:
            defaultName = _('Standby');
        break;
        case 64:
            defaultName = _('Auto Standby');
        break;
        case 40:
            defaultName = _('Auto Off');
        break;
        case 41:
            defaultName = _('Impulse');
        break;
        case 68:
            defaultName = _('Deep Off');
        break;
        case 69:
            defaultName = _('Sleeping');
        break;
        case 70:
            defaultName = _('Wake up');
        break;
        case 72:
            defaultName = _('Absent');
        break;
        case 71:
            defaultName = _('Present');
        break;
        case 73:
            defaultName = _('Bell');
        break;
        
        case 74:
            defaultName = _('Alarm 1');
        break;
        case 83:
            defaultName = _('Alarm 2');
        break;
        case 84:
            defaultName = _('Alarm 3');
        break;
        case 85:
            defaultName = _('Alarm 4');
        break;
        case 88:
            defaultName = _('Rain');
        break;
        case 89:
            defaultName = _('no Rain');
        break;
        case 90:
            defaultName = _('Hail');
        break;
        case 91:
            defaultName = _('no Hail');
        break;
        case 76:
            defaultName = _('Fire');
        break;
                
        case 65:
            defaultName = _('Panic');
        break;
        case 0:
            if (group == 2)
                defaultName = _('Close');
            else
                defaultName = _('Off');
        break;
        case 5:
            if (group == 2)
                defaultName = _('Open');
            else if (group == 48)
            	defaultName = _('HOLIDAY Mode');
            else
                defaultName = _('scene 1');
        break;
        case 17:
            defaultName = _('scene 2');
        break;
        case 15:
            defaultName = _('Stop');
        break;
        case 18:
            defaultName = _('scene 3');
        break;
        case 19:
            defaultName = _('scene 4');
        break;
        case 1:
            if (group == 2)
                defaultName = _('area 1 close');
            else if (group == 48)
            	defaultName = _('COMFORT Mode');
            else
                defaultName = _('area 1 off');
        break;
        case 6:
            if (group == 2)
                defaultName = _('area 1 open');
            else
                defaultName = _('area 1 on');
        break;
        case 2:
            if (group == 2)
                defaultName = _('area 2 close');
            else if (group == 48)
            	defaultName = _('ECO Mode');
            else
                defaultName = _('area 2 off');
        break;
        case 7:
            if (group == 2)
                defaultName = _('area 2 open');
            else
                defaultName = _('area 2 on');
        break;
        case 3:
            if (group == 2)
                defaultName = _('area 3 close');
            else if (group == 48)
            	defaultName = _('NotUsed Mode');
            else
                defaultName = _('area 3 off');
        break;
        case 8:
            if (group == 2)
                defaultName = _('area 3 open');
            else
                defaultName = _('area 3 on');
        break;
        case 4:
            if (group == 2)
                defaultName = _('area 4 close');
            else if (group == 48)
            	defaultName = _('NIGHT Mode');
            else
                defaultName = _('area 4 off');
        break;
        case 9:
            if (group == 2)
                defaultName = _('area 4 open');
            else
                defaultName = _('area 4 on');
        break;
        case 32:
            defaultName = _('scene 10');
        break;
        case 33:
            defaultName = _('scene 11');
        break;
        case 34:
            defaultName = _('scene 20');
        break;
        case 35:
            defaultName = _('scene 21');
        break;
        case 36:
            defaultName = _('scene 30');
        break;
        case 37:
            defaultName = _('scene 31');
        break;
        case 38:
            defaultName = _('scene 40');
        break;
        case 39:
            defaultName = _('scene 41');
        break;
        case 20:
            defaultName = _('scene 12');
        break;
        case 21:
            defaultName = _('scene 13');
        break;
        case 22:
            defaultName = _('scene 14');
        break;
        case 23:
            defaultName = _('scene 22');
        break;
        case 24:
            defaultName = _('scene 23');
        break;
        case 25:
            defaultName = _('scene 24');
        break;
        case 26:
            defaultName = _('scene 32');
        break;
        case 27:
            defaultName = _('scene 33');
        break;
        case 28:
            defaultName = _('scene 34');
        break;
        case 29:
            defaultName = _('scene 42');
        break;
        case 30:
            defaultName = _('scene 43');
        break;
        case 31:
            defaultName = _('scene 44');
        break;
        case 50:
            defaultName = _('local off');
        break;
        case 51:
            defaultName = _('local on');
        break;
    }
    return defaultName;
};

dss.staticDataModel.getNameForScene = function(zoneID, group, scene) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var baseName = "";

    switch (scene) {
        case 67:
            baseName = 'STANDBY';
        break;
        case 64:
            baseName = 'AUTO_STANDBY';
        break;
        case 40:
            baseName = 'AUTO_OFF';
        break;
        case 68:
            baseName = 'DEEP_OFF';
        break;
        case 69:
            baseName = 'SLEEPING';
        break;
        case 70:
            baseName = 'WAKE_UP';
        break;
        case 72:
            baseName = 'ABSENT';
        break;
        case 71:
            baseName = 'PRESENT';
        break;
        case 73:
            baseName = 'SIG_BELL';
        break;
        case 65:
            baseName = 'PANIC';
        break;
        case 0:
            baseName = 'T0_S0';
        break;
        case 5:
            baseName = 'T0_S1';
        break;
        case 17:
            baseName = 'T0_S2';
        break;
        case 18:
            baseName = 'T0_S3';
        break;
        case 19:
            baseName = 'T0_S4';
        break;
        case 1:
            baseName = 'T1_S0';
        break;
        case 6:
            baseName = 'T1_S1';
        break;
        case 2:
            baseName = 'T2_S0';
        break;
        case 7:
            baseName = 'T2_S1';
        break;
        case 3:
            baseName = 'T3_S0';
        break;
        case 8:
            baseName = 'T3_S1';
        break;
        case 4:
            baseName = 'T4_S0';
        break;
        case 9:
            baseName = 'T4_S1';
        break;
        case 32:
            baseName = 'T1E_S0';
        break;
        case 33:
            baseName = 'T1E_S1';
        break;
        case 34:
            baseName = 'T2E_S0';
        break;
        case 35:
            baseName = 'T2E_S1';
        break;
        case 36:
            baseName = 'T3E_S0';
        break;
        case 37:
            baseName = 'T3E_S1';
        break;
        case 38:
            baseName = 'T4E_S0';
        break;
        case 39:
            baseName = 'T4E_S1';
        break;
        case 20:
            baseName = 'T1_S2';
        break;
        case 21:
            baseName = 'T1_S3';
        break;
        case 22:
            baseName = 'T1_S4';
        break;
        case 23:
            baseName = 'T2_S2';
        break;
        case 24:
            baseName = 'T2_S3';
        break;
        case 25:
            baseName = 'T2_S4';
        break;
        case 26:
            baseName = 'T3_S2';
        break;
        case 27:
            baseName = 'T3_S3';
        break;
        case 28:
            baseName = 'T3_S4';
        break;
        case 29:
            baseName = 'T4_S2';
        break;
        case 30:
            baseName = 'T4_S3';
        break;
        case 31:
            baseName = 'T4_S4';
        break;
    }

    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            for ( var iGroupIndex = 0; iGroupIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iGroupIndex++)
                if ((dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].group == group) &&
                    (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes !== undefined))
                    for ( var iSceneIndex = 0; iSceneIndex < dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes.length; iSceneIndex++)
                        if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].scene == scene)
                            if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != null)
                                if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != '')
                                    if (dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name != baseName)
                                        return dss.staticDataModel.nameCache[iZoneIndex].groups[iGroupIndex].scenes[iSceneIndex].name;
    return dss.staticDataModel.getDefaultNameForScene(zoneID, group, scene);
};

dss.staticDataModel.getNameForZone = function(zoneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var baseName = Ext.String.format2(_('Room ID {zone}'), {zone:zoneID});
    if (zoneID == 0)
        baseName = _('whole installation');
    if (zoneID == -1)
        baseName = _('any room');    
    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID)
            if (dss.staticDataModel.nameCache[iZoneIndex].name != "")
                return dss.staticDataModel.nameCache[iZoneIndex].name;
    return baseName;
};

dss.staticDataModel.getGroupForZone = function(zoneID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    for ( var iZoneIndex = 0; iZoneIndex < dss.staticDataModel.nameCache.length; iZoneIndex++)
        if (dss.staticDataModel.nameCache[iZoneIndex].ZoneID == zoneID) {
            var oResult = [];
            for ( var iIndex = 0; iIndex < dss.staticDataModel.nameCache[iZoneIndex].groups.length; iIndex++)
            	if (dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].group!=6)
                	if (dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].group!=7)
                        if ((dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].group<16)|| ((zoneID==0)&&dss.staticDataModel.isClusterGroup(dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].group)))
                            oResult.push({
                                'group' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].group,
                                'name' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].name,
                                'icon' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].icon,
                                'reachable' : dss.staticDataModel.nameCache[iZoneIndex].groups[iIndex].reachable
                            });
            return oResult;
        }
    return null;
};

dss.staticDataModel.getDevice = function(dSUID) {
    if (dss.staticDataModel.nameCache == null) {
        dss.staticDataModel.initCaches();
    }
    if (DSS.types.dsuid.isDSUID(dSUID)) {
        for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
            if (dSUID == dss.staticDataModel.deviceCache[i].dSUID)
                return dss.staticDataModel.deviceCache[i];
        }
        return {
            dSID : DSS.types.dsuid.dsuid_to_dsid(dSUID),
            dSUID : dSUID,
            name : "",
            functionID : 0x1000
        };
    } else {
        for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
            if (dSUID == dss.staticDataModel.deviceCache[i].dSID)
                return dss.staticDataModel.deviceCache[i];
        }
        return {
            dSID : dSUID,
            dSUID : DSS.types.dsuid.dsuid_from_dsid(dSUID),
            name : "",
            functionID : 0x1000
        };        
    }
};

dss.staticDataModel.getImagePathForScene = function(zoneID, groupID, sceneID, fUndoIcon) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    if (fUndoIcon==null)
        fUndoIcon=false;
    var fUndoPrefix="";
    if (fUndoIcon)
        fUndoPrefix='undo_';
    var baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_1"; 
    if (zoneID==0)
	    if (dss.staticDataModel.isClusterGroup(groupID))
	    {
	    	groupID=dss.staticDataModel.getUserGroupColor(groupID);
	    } 
    if (groupID==48) {
    	groupID=3;
    	if (sceneID==1)
    		sceneID=5;
    	if (sceneID==2)
    		sceneID=5;
    	if (sceneID==3)
    		sceneID=0;
    	if (sceneID==4)
    		sceneID=0;
    	if (sceneID==5)
    		sceneID=0;
    }
    	
    switch (groupID) {
        case 1:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_1";

        break;
        case 2:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_2";
            if (sceneID == 5)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 6)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 7)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 8)
                return baseGroupName + '_scene_5.png';
            if (sceneID == 9)
                return baseGroupName + '_scene_5.png';
        break;
        case 3:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_3";
        break;
        case 4:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_4";
        break;
        case 5:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_5";
        break;
        case 6:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_6";
        break;
        case 7:
            baseGroupName = dss.staticDataModel.baseImagePath + "groupIcons/"+fUndoPrefix+"group_7";
        break;
    }
    switch (sceneID) {
        case 0:
        case 1:
        case 2:
        case 3:
        case 4:
        case 32:
        case 34:
        case 36:
        case 38:
        case 50:
            return baseGroupName + '_deact.png';
        break;
        case 40:
            return baseGroupName + '_auto_off.png';
        break;    
        case 5:
        case 6:
        case 7:
        case 8:
        case 9:
        case 17:
        case 18:
        case 19:
        case 20:
        case 21:
        case 22:
        case 23:
        case 24:
        case 25:
        case 26:
        case 27:
        case 28:
        case 29:
        case 30:
        case 31:
        case 33:
        case 35:
        case 37:
        case 39:
        case 51:
            return baseGroupName + '_active.png';
        break;
        case 15:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_stop.png';
        break;
        case 64:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_standby.png';
        break;
        case 65:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_panic.png';
        break;
        case 67:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_standby.png';
        break;
        case 68:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_deep_off.png';
        break;
        case 69:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_sleeping.png';
        break;
        case 70:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_wakeup.png';
        break;
        case 71:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_present.png';
        break;
        case 72:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_absent.png';
        break;
        case 73:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_bell.png';
        break;
        case 74:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_alarm1.png';
        break;
        case 83:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_alarm2.png';
        break;
        case 84:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_alarm3.png';
        break;
        case 85:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_alarm4.png';
        break;
        case 88:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_rain.png';
        break;
        case 89:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_norain.png';
        break;
        case 90:
            return dss.staticDataModel.baseImagePath + 'state/hail.png';
        break;
        case 91:
            return dss.staticDataModel.baseImagePath + 'state/hail_No.png';
        break;
        case 76:
            return dss.staticDataModel.baseImagePath + 'sceneIcons/'+fUndoPrefix+'scene_fire.png';
        break;
        
    }
};

dss.staticDataModel.getScene = function(zoneId, groupId,sceneID) {
    var oSceneArray=dss.staticDataModel.getScenes(zoneId, groupId);
    for (var iIndex=0;iIndex<oSceneArray.length;iIndex++) {
        if (oSceneArray[iIndex].id==sceneID)
            return oSceneArray[iIndex]; 
    }
    return null;
};

dss.staticDataModel.getScenes = function(zoneId, groupId) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var oDeviceArray = dss.staticDataModel.getDevicesForZone(zoneId, groupId);

    var oRetArray = [];
    var sceneArray = [ 0, 5, 17, 18, 19, 1, 6, 2, 7, 3, 8, 4, 9, 32, 33, 20, 21, 22, 34, 35, 23, 24, 25, 36, 37, 26, 27, 28, 38, 39, 29, 30, 31, 67,
            64, 68, 69, 70, 72, 71, 73, 65, 76, 74, 83, 84, 85, 88, 89];
    if (groupId==1)
    	sceneArray = [ 0, 40, 5, 17, 18, 19, 1, 6, 2, 7, 3, 8, 4, 9, 32, 33, 20, 21, 22, 34, 35, 23, 24, 25, 36, 37, 26, 27, 28, 38, 39, 29, 30, 31, 67,
                                  64, 68, 69, 70, 72, 71, 73, 65, 76, 74, 83, 84, 85, 88, 89];
    if (zoneId==0)
    	if (groupId==0) {
    		sceneArray.push(90);
    		sceneArray.push(91);
    	}
    if (groupId == 2)
    {
        sceneArray.splice(33,0,15);
    }

    for ( var iIndex = 0; iIndex < sceneArray.length; iIndex++) {
        var oSzeneObject = {
            id : sceneArray[iIndex],
            groupID : groupId,
            zoneID : zoneId,
            reachable : false,
            undoable:false
        };
        oSzeneObject.name = dss.staticDataModel.getNameForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oSzeneObject.defaultName = dss.staticDataModel.getDefaultNameForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oSzeneObject.icon = dss.staticDataModel.getImagePathForScene(oSzeneObject.zoneID, oSzeneObject.groupID, oSzeneObject.id);
        oRetArray.push(oSzeneObject);
    }

    
    function searchAndEnableScene(id) {
        for ( var iIndex = 0; iIndex < oRetArray.length; iIndex++)
            if (oRetArray[iIndex].id == id)
                oRetArray[iIndex].reachable = true;
    }
    
    function searchAndSetUndo(id,undo) {
        for ( var iIndex = 0; iIndex < oRetArray.length; iIndex++)
            if (oRetArray[iIndex].id == id)
                oRetArray[iIndex].undoable = undo;
    }
    
    if (groupId != 7)
    	if (groupId != 6)
    if (groupId != 0) {
        for ( var iDeviceIndex = 0; iDeviceIndex < oDeviceArray.length; iDeviceIndex++) {
            var oDev = oDeviceArray[iDeviceIndex];
            
            if (oDev.tasterMode>0) {
                if (groupId == 2)
                {
                    searchAndEnableScene(15);
                }
                if (groupId == 1) 
                {
                	searchAndEnableScene(40);
                }
            }
            
            switch (oDev.tasterMode) {
                case 0:
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                    searchAndEnableScene(5);
                    searchAndEnableScene(0);
                break;
                case 1:
                    searchAndEnableScene(1);
                    searchAndEnableScene(6);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 2:
                    searchAndEnableScene(2);
                    searchAndEnableScene(7);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 3:
                    searchAndEnableScene(3);
                    searchAndEnableScene(8);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 4:
                    searchAndEnableScene(4);
                    searchAndEnableScene(9);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 5:
                    searchAndEnableScene(0);
                    searchAndEnableScene(5);
                    searchAndEnableScene(17);
                    searchAndEnableScene(18);
                    searchAndEnableScene(19);
                break;
                case 6:
                    searchAndEnableScene(32);
                    searchAndEnableScene(33);
                    searchAndEnableScene(20);
                    searchAndEnableScene(21);
                    searchAndEnableScene(22);
                break;
                case 7:
                    searchAndEnableScene(34);
                    searchAndEnableScene(35);
                    searchAndEnableScene(23);
                    searchAndEnableScene(24);
                    searchAndEnableScene(25);
                break;
                case 8:
                    searchAndEnableScene(36);
                    searchAndEnableScene(37);
                    searchAndEnableScene(26);
                    searchAndEnableScene(27);
                    searchAndEnableScene(28);
                break;
                case 9:
                    searchAndEnableScene(38);
                    searchAndEnableScene(39);
                    searchAndEnableScene(29);
                    searchAndEnableScene(30);
                    searchAndEnableScene(31);
                break;
                case 10:
                    searchAndEnableScene(1);
                    searchAndEnableScene(6);
                    searchAndEnableScene(20);
                    searchAndEnableScene(21);
                    searchAndEnableScene(22);
                break;
                case 11:
                    searchAndEnableScene(2);
                    searchAndEnableScene(7);
                    searchAndEnableScene(23);
                    searchAndEnableScene(24);
                    searchAndEnableScene(25);
                break;
                case 12:
                    searchAndEnableScene(3);
                    searchAndEnableScene(8);
                    searchAndEnableScene(26);
                    searchAndEnableScene(27);
                    searchAndEnableScene(28);
                break;
                case 13:
                    searchAndEnableScene(4);
                    searchAndEnableScene(9);
                    searchAndEnableScene(29);
                    searchAndEnableScene(30);
                    searchAndEnableScene(31);
                break;
            }
        }
        
    }
    if ((zoneId != 0) && (groupId == 0)) {
        searchAndEnableScene(67);
        searchAndEnableScene(68);
        searchAndEnableScene(69);
        searchAndEnableScene(70);
    }

    if ((zoneId == 0) && (groupId == 0)) {
        for ( var i = 0; i < dss.staticDataModel.deviceCache.length; i++) {
            var oDeviceObject = dss.staticDataModel.deviceCache[i];
            if (oDeviceObject.functionID == 0x7010)
                searchAndEnableScene(73); // klingel
            if (oDeviceObject.functionID == 0x6001) {
                searchAndEnableScene(65); // panik
            }
            if (oDeviceObject.functionID == 0x7050) {
                searchAndEnableScene(71); // kommen
                searchAndEnableScene(72); // gehen
            }
        }
        searchAndEnableScene(67);
        searchAndEnableScene(68);
        searchAndEnableScene(69);
        searchAndEnableScene(70);
    }
    searchAndSetUndo(65,true);
    
    if (zoneId==0)
    	if (groupId==0) {
    	    searchAndEnableScene(90);
    	    searchAndEnableScene(91);
    	}

    if (groupId === 4) {
        searchAndEnableScene(0); //preset0
        searchAndEnableScene(5); //preset1
        searchAndEnableScene(17); //preset2
        searchAndEnableScene(18); //preset3
        searchAndEnableScene(19); //preset4
        
        //searchAndEnableScene(32); //preset10
        //searchAndEnableScene(33); //preset11
        //searchAndEnableScene(20); //preset12
        //searchAndEnableScene(21); //preset13
        //searchAndEnableScene(22); //preset14
        
        //searchAndEnableScene(34); //preset20
        //searchAndEnableScene(35); //preset21
        //searchAndEnableScene(23); //preset22
        //searchAndEnableScene(24); //preset23       
        //searchAndEnableScene(25); //preset24
        
        //searchAndEnableScene(36); //preset30
        //searchAndEnableScene(37); //preset21
        //searchAndEnableScene(26); //preset32
        //searchAndEnableScene(27); //preset33
        //searchAndEnableScene(28); //preset34
        
        //searchAndEnableScene(38); //preset40
        //searchAndEnableScene(39); //preset41
        //searchAndEnableScene(29); //preset42
        //searchAndEnableScene(30); //preset43
        //searchAndEnableScene(31); //preset44
    }

    searchAndSetUndo(76,true);
    searchAndSetUndo(74,true);
    searchAndSetUndo(83,true);
    searchAndSetUndo(84,true);
    searchAndSetUndo(85,true);

    return oRetArray;
};

dss.staticDataModel.getUserGroupColor = function(groupID) {
	var oArray=dss.staticDataModel.getUsergroups();
	if (oArray!=null)
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		if (oArray[iIndex].id==groupID)
			return oArray[iIndex].color;
	}
	return -1;
};

dss.staticDataModel.getUserGroupName = function(groupID) {
	var oArray=dss.staticDataModel.getUsergroups();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		if (oArray[iIndex].id==groupID)
			return oArray[iIndex].name;
	}
	return "";
};

dss.staticDataModel.isClusterGroup = function (groupID) {
	return ((groupID >= 16) && (groupID < 40));
}

dss.staticDataModel.getImagePathForGroup = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    
    if (zoneID==0)
        if (dss.staticDataModel.isClusterGroup(groupID)) {
            switch(dss.staticDataModel.getUserGroupColor(groupID)) {
            case 1:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_yellow.png';
            break;
            case 2:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_grey.png';
            break;
            case 3:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_blue.png';
            break;
            case 4:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_cyan.png';
            break;
            case 5:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_magenta.png';
            break;
            case 6:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_red.png';
            break;
            case 7:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_green.png';
            break;
            case 8:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_black.png';
            break;
            case 9:
                return dss.staticDataModel.baseImagePath + 'groupIcons/usergroup_whitewea.png';
            break;
            }
        }
    
    
    switch (groupID) {
        case 0:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_0.png';
        break;
        case 1:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_1.png';
        break;
        case 2:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_2.png';
        break;
        case 3:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_3.png';
        break;
        case 4:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_4.png';
        break;
        case 5:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_5.png';
        break;
        case 6:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_6.png';
        break;
        case 7:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_7.png';
        break;
        case 8:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_8.png';
        break;
        case 9:
            return dss.staticDataModel.baseImagePath + 'groupIcons/group_9.png';
        break;
        case 10:
            return dss.staticDataModel.baseImagePath + 't.gif';
        break;
    }
};

dss.staticDataModel.getImageForScene = function(zoneID, groupID, sceneID,fUndoIcon) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    
    return '<img src="' + dss.staticDataModel.getImagePathForScene(zoneID, groupID, sceneID,fUndoIcon) + '" alt="'
            + dss.staticDataModel.getNameForScene(zoneID, groupID, sceneID) + '">';
};

dss.staticDataModel.getImageForGroup = function(zoneID, groupID) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return '<img src="' + dss.staticDataModel.getImagePathForGroup(zoneID, groupID) + '" alt="'
            + dss.staticDataModel.getNameForGroup(zoneID, groupID) + '">';

};

dss.staticDataModel.getImageForDevice = function(device) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    if (device.dSUID) {
        return "/icons/getDeviceIcon?dsuid=" + device.dSUID;
    } else {
        return "/icons/getDeviceIcon?dsid=" + device.dSID;
    }
};

dss.staticDataModel.getDeviceType = function(device) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    return ((device.productID >> 10) & 0x3f);
};

dss.staticDataModel.getProductNameForDevice = function(device) {
    if (dss.staticDataModel.nameCache == null)
        dss.staticDataModel.initCaches();
    var sName = "";

    switch ((device.functionID & 0xf000) >> 12) {
        case 1:
            sName += "GE";
        break;
        case 2:
            sName += "GR";
        break;
        case 3:
            sName += "BL";
        break;
        case 4:
            sName += "TK";
        break;
        case 5:
            sName += "MG";
        break;
        case 6:
            sName += "RT";
        break;
        case 7:
            sName += "GN";
        break;
        case 8:
            sName += "SW";
        break;
        case 9:
            sName += "WE";
        break;
    }
    sName+='-';
    switch ((device.productID >> 10) & 0x3f) {
        case 0:
            sName+='KM';
        break;
        case 1:
            sName+='TKM';
        break;
        case 2:
            sName+='SDM';
        break;
        case 3:
            sName+='KL';
        break;
        case 4:
            sName+='TUP';
        break;
        case 5:
            sName+='ZWS';
        break;
        case 6:
            sName+='SDS';
        break;
        case 8:
            sName+='AKM';
        break;
        case 10:
            sName+='TNY';
        break;
        case 11:
            sName+='UMV';
        break;
        case 12:
            sName+='UMR';
        break;
    }
    var deviceNumber = (device.productID & 0x3ff);
    //remove housing colour 
    if (200 < deviceNumber < 210) {
        deviceNumber = 200;
    }
    return sName + ' ' + deviceNumber;
};

dss.staticDataModel.getTooltipForDevice = function(device) {
	//TODO dsuid
	return '<table>' + 
	'<tr><td>'+_('Produkt')+':</td><td>' + dss.staticDataModel.getProductNameForDevice(device) + '</td></tr>'+
	'<tr><td>'+_('Room')+':</td><td>' + dss.staticDataModel.getNameForZone(device.ZoneID) + '</td></tr>' +
	'<tr><td>'+_('Meter')+':</td><td>' + dss.staticDataModel.getMeterName(device.DSMeterDSUID) + '</td></tr>' + 
    '<tr><td>'+_('ID')+':</td><td colspan=&quot;2&quot;>' + device.DisplayID + '</td></tr></table>';
	return "";
};

dss.staticDataModel.getTooltipForState = function(type,value) {
	switch (type) {
	case 7:
		if (value) 
			return _('If smoke is detected, a fire alarm will be raised automaticly by default');
		break;
	case 8:
		if (value) 
			return _('If wind is detected, a wind alarm will be raised automaticly by default');
		break;
	case 9:
		if (value) 
			return _('If rain is detected, a rain alarm will be raised automaticly by default');
		break;
	case 13:
		if (value) {
			return _('The window is either tilted or completely open');
        } else {
            return _('The window is completely closed');
        }
		break;
	case 14:
		if (value) {
			return _('The door is open');
        } else {
			return _('The door is closed');            
        }
		break;
	case 15:
		if (value) {
			return _('The window is tilted open');
        } else {
            return _('The window is fully open');
        }
		break;
	}	
	return '';
};

dss.staticDataModel.IsWindowHandle = function (oDevice) {
    var bResult = false;
    if (oDevice.binaryInputs.length > 1) {
        for (var iIndex=0;iIndex<oDevice.binaryInputs.length;iIndex++) {
            if (oDevice.binaryInputs[iIndex].type == 15) {
                bResult = true;
            }
        }
    } 
    return bResult;
};


/*
 * oJsonObject: Typical dss-Answer Object paramDef: array of expected Objects in
 * AnswerArray { name: properyName, type:
 * simple|action|trigger|condition/enabled }
 */
dss.parsePropertyQueryAnswer = function(oJsonObject, paramDef) {
    if (oJsonObject.ok == null)
        return null;
    if (!oJsonObject.ok)
        return null;
    if (oJsonObject.result == null)
        return null;
    var oReturnArray = [];
    for ( var sKey in oJsonObject.result) {
        var oRootArray = oJsonObject.result[sKey];
        for ( var iIndex = 0; iIndex < oRootArray.length; iIndex++) {
            var oObject = {};
            var oIteratorObject = oRootArray[iIndex];
            for ( var sIndex = 0; sIndex < paramDef.length; sIndex++) {
                var oKeyParameter = paramDef[sIndex].name;

                if (paramDef[sIndex].type == 'simple') {
                    if (oIteratorObject[oKeyParameter] != null)
                        oObject[oKeyParameter] = escape(dss.unescapeProperty(oIteratorObject[oKeyParameter]));
                    else
                        oObject[oKeyParameter] = null;
                } else if (paramDef[sIndex].type == 'date') {
                    if (oIteratorObject[oKeyParameter] != null) 
                        oObject[oKeyParameter] = new Date(parseInt(oIteratorObject[oKeyParameter],10)*1000);
                    
                } else if ((paramDef[sIndex].type == 'action') || (paramDef[sIndex].type == 'trigger')) {
                    oObject[oKeyParameter] = [];
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject[oKeyParameter] != null) {

                                    for ( var kIndex = 0; kIndex < oArrayObject[oKeyParameter].length; kIndex++) {
                                        var resultObject = oArrayObject[oKeyParameter][kIndex];
                                        var oActionObject = {};
                                        for ( var oKey in resultObject) {
                                            oActionObject[oKey] = resultObject[oKey];
                                            if (oKey=='type')
                                            	if (oActionObject[oKey]=='bus-zone-scene')
                                            		oActionObject[oKey]='zone-scene';
                                        }
                                        oObject[oKeyParameter].push(oActionObject);
                                    }

                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'condition')) {
                	var oConditionObject={
                	        enabled: null, // singular value
                	        weekdays: null, // singularvalue
                	        timeframe: null, // array ....
                	        zoneState:null,
                	        systemState:null
                	};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject[oKeyParameter] != null) {
                                	if (oArrayObject['enabled']!=null) {
                                		oConditionObject.enabled=oArrayObject['enabled'];
                                	}
                                	if ((oArrayObject['time-start']!=null) && (oArrayObject['time-end']!=null)) {
                                		var startArray=oArrayObject['time-start'].split(':');
                                		var iStart=parseInt(startArray[0],10)*3600 + parseInt(startArray[1],10)*60 + parseInt(startArray[2],10); 
                                		var endArray=oArrayObject['time-end'].split(':');
                                		var iEnd=parseInt(endArray[0],10)*3600 + parseInt(endArray[1],10)*60 + parseInt(endArray[2],10); 
                                		oConditionObject.timeframe=[{start: {timeBase:'daily',offset:iStart},
                                			                         end: {timeBase:'daily',offset:iEnd} }];
                                    }
                                	if (oArrayObject['weekdays']!=null) {
                                		var weekArray=oArrayObject['weekdays'].split(',');
                                		oConditionObject.weekdays=[];
                                		for (var wIndex=0;wIndex<weekArray.length;wIndex++) {
                                			switch (weekArray[wIndex]) {
	                                			case '0':
		                            				oConditionObject.weekdays.push('SU');
		                            			break;
	                                			case '1':
		                            				oConditionObject.weekdays.push('MO');
		                            			break;
	                                			case '2':
		                            				oConditionObject.weekdays.push('TU');
		                            			break;
	                                			case '3':
		                            				oConditionObject.weekdays.push('WE');
		                            			break;
	                                			case '4':
		                            				oConditionObject.weekdays.push('TH');
		                            			break;
	                                			case '5':
		                            				oConditionObject.weekdays.push('FR');
		                            			break;
	                                			case '6':
		                            				oConditionObject.weekdays.push('SA');
		                            			break;
                                			}
                                		}
                                	}
                                    for ( var kIndex = 0; kIndex < oArrayObject[oKeyParameter].length; kIndex++) {
                                        var resultObject = oArrayObject[oKeyParameter][kIndex];
                                        if (resultObject.states!=null) {
                                        	oConditionObject.systemState=[];
                                        	for (var sKey in resultObject) {
                                        		if (sKey!='states') {
                                        			oConditionObject.systemState.push({name:sKey,value:resultObject[sKey]});
                                        		}
                                        	}
                                        }
                                        if (resultObject['zone-states']!=null) {
                                        	oConditionObject.zoneState=[];
                                        	for (var zIndex=0;zIndex<resultObject['zone-states'].length;zIndex++) {
                                        		oConditionObject.zoneState.push({zone:resultObject['zone-states'][zIndex].zone,group:resultObject['zone-states'][zIndex].group,scene:resultObject['zone-states'][zIndex].scene});	
                                        	}
                                        }
                                        if (resultObject['addon-states']!=null) {
                                        	oConditionObject.addonStates=[];
                                        	for (var sKey in resultObject['addon-states']) {
                                        		var value;
                                        		var name;
                                        		var addonID;
	                                        	for (var stateName in resultObject['addon-states'][sKey])
	                                        	{
	                                        		if (resultObject['addon-states'][sKey][stateName]===1) {
	                                        			value=1;
	                                        			name=stateName;
	                                        		} else
	                                        		if (resultObject['addon-states'][sKey][stateName]===2) {
	                                        			value=2;
	                                        			name=stateName;
	                                        		} else {
	                                        			addonID=stateName;
	                                        		}	                                        			
	                                        	}
                                        		oConditionObject.addonStates.push({scriptID:addonID,name:name,value:value});
                                        	}
                                        }
                                    }

                                }
                            }
                        }
                    }    
                    oObject[oKeyParameter]=oConditionObject;

                } else if ((paramDef[sIndex].type == 'condition/enabled')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.conditions != null)
                                    if (oArrayObject.enabled != null)
                                        oObject[oKeyParameter] = !oArrayObject.enabled;
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'condition/state')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.conditions != null) {
                                    for (var kIndex=0 ; kIndex<oArrayObject.conditions.length; kIndex++) {
                                        if (oArrayObject.conditions[kIndex]!=null) {
                                            if (oArrayObject.conditions[kIndex][paramDef[sIndex].name]!=null)
                                                oObject[oKeyParameter] = oArrayObject.conditions[kIndex][paramDef[sIndex].name];
                                        }
                                    }
                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'message')) {
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.message != null) {
                                    oObject[oKeyParameter] = {};
                                    oObject[oKeyParameter].messageType = oArrayObject.messageType;
                                    oObject[oKeyParameter].receiver = oArrayObject.receiver;
                                    oObject[oKeyParameter].subject = escape(dss.unescapeProperty(oArrayObject.subject));
                                    oObject[oKeyParameter].message = escape(dss.unescapeProperty(oArrayObject.messageBody));
                                }
                            }
                        }
                    }
                } else if ((paramDef[sIndex].type == 'recurrence')) {
                    var oTimeObject = {};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.recurrenceBase != null)
                                    oTimeObject.recurrenceBase = oArrayObject.recurrenceBase;
                                if (oArrayObject.time != null) {
                                    oTimeObject.timeArray = [];
                                    for ( var oKey in oArrayObject.time) {
                                        var oSubArray = oArrayObject.time[oKey];
                                        for ( var aKey in oSubArray) {
                                            if (oSubArray[aKey] != null) 
                                            	if (typeof(oSubArray[aKey])=='string')
	                                                oTimeObject.timeArray.push(oSubArray[aKey]);
	                                        
                                        }
                                    }
                                }
                            }
                        }
                    }
                    oObject[oKeyParameter] = oTimeObject;
                } else if ((paramDef[sIndex].type == 'time')) {
                    var oTimeObject = {};
                    for ( var subIndex in oIteratorObject) {
                        if (typeof (oIteratorObject[subIndex]) == "object") {
                            var aArray = oIteratorObject[subIndex];
                            for ( var jIndex = 0; jIndex < aArray.length; jIndex++) {
                                var oArrayObject = aArray[jIndex];
                                if (oArrayObject.timeBase != null)
                                    oTimeObject.timeBase = oArrayObject.timeBase;
                                if (oArrayObject.offset != null)
                                    oTimeObject.offset = oArrayObject.offset;
                                if (oArrayObject.limitBefore != null)
                                    oTimeObject.limitBefore = oArrayObject.limitBefore;
                                if (oArrayObject.limitAfter != null)
                                    oTimeObject.limitAfter = oArrayObject.limitAfter;
                                if (oArrayObject.random != null)
                                    oTimeObject.random = oArrayObject.random;
                            }
                        }
                    }
                    oObject[oKeyParameter] = oTimeObject;
                }
            }
            oReturnArray.push(oObject);
        }

    }
    return oReturnArray;
};

dss.validateTriggerObject = function (oTriggerObject) {
	 switch (oTriggerObject.type) {
	 	case 'state-change' : {
	 		
	 		if (oTriggerObject.name.split('_')[0]=='uds') {
 				var idString =oTriggerObject.name.split('_')[1];
 				var oUserStates=dss.staticDataModel.getUserStates();
    			var sStringValue;
    			for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
        			if (oUserStates[iIndex].id==idString) {
    	 				if (oTriggerObject.state=='active')
    	 					return dss.validValue.ok;
    	 				if (oTriggerObject.state=='inactive')
    	 					return dss.validValue.ok;
        			}
    			}
 			}
	 		
        	var oArray=oTriggerObject.name.split('.');
        	if (oArray.length==3) 
            	if (oArray[0]=='dev')
            	{
                    //TODO das ist bis jetzt keine dsuid
            		var oDevice=dss.staticDataModel.getDevice(oArray[1]);
            		
            		if (oDevice!=null) 
            			if (oDevice.binaryInputs!=null)
            			{
	            			var typeIndex=parseInt(oArray[2],10);
	                        var type=255;
	                        for (var kIndex=0;kIndex<oDevice.binaryInputs.length;kIndex++)
	                        	if (oDevice.binaryInputs[kIndex].index==typeIndex)
	                        		type=oDevice.binaryInputs[kIndex].type;
	                        if (type!=255) {
		                        if (oTriggerObject.state=='active')
		                        	return dss.validValue.ok;
		                        if (oTriggerObject.state=='inactive')
		                        	return dss.validValue.ok;
                        }
            		}
            	}
        		if (oArray[0]=='zone') {
        			for (var iIndex=0;iIndex<dss.staticDataModel.getStates().length;iIndex++) 
        				if (dss.staticDataModel.getStates()[iIndex].name==oTriggerObject.name) {
	                        if (oTriggerObject.state=='active')
	                        	return dss.validValue.ok;
	                        if (oTriggerObject.state=='inactive')
	                        	return dss.validValue.ok;
        				}
        		}
                if (oArray[0] == 'cluster') {
                    for (var iIndex=0; iIndex < dss.staticDataModel.getStates().length; iIndex++) {
                        if (dss.staticDataModel.getStates()[iIndex].name == oTriggerObject.name) {
                            if (oTriggerObject.state == 'active') {
                                return dss.validValue.ok;
                            }
                            if (oTriggerObject.state == 'inactive') {
                                return dss.validValue.ok;
                            }
                        }
                    }
                }
        	
                        
	 		switch (oTriggerObject.name) {
	 			case 'fire':
	 			case 'hail':
	 			case 'rain':
	 			case 'wind':
	 			case 'frost':
	 			case 'sun':
	 			case 'service':
	 				if (oTriggerObject.state=='active')
	 					return dss.validValue.ok;
	 				if (oTriggerObject.state=='inactive')
	 					return dss.validValue.ok;
		 			break;
	 			case 'heating_mode':
	 				if (oTriggerObject.state=='off')
	 					return dss.validValue.ok;
	 				if (oTriggerObject.state=='heating')
	 					return dss.validValue.ok;
	 				if (oTriggerObject.state=='cooling')
	 					return dss.validValue.ok;
	 				if (oTriggerObject.state=='auto')
	 					return dss.validValue.ok;
		 			break;
	 		}
	 	}
	 	case 'device-sensor': {
            var oDevice = dss.staticDataModel.getDevice(oTriggerObject.dsuid);
            if (oDevice.present===null) {
                return dss.validValue.completlyWrong;  // gel�schtes ger�t -> vollkommen falsch
            }
            if (!oDevice.present) {
                return dss.validValue.temporaryWrong;  // nicht vorhandene Geraete -> Fehler
            }
            if (oDevice.sensorEvents==null)
            	return dss.validValue.completlyWrong;
		    for (var iIndex=0;iIndex<oDevice.sensorEvents.length;iIndex++) {
		        if (oDevice.sensorEvents[iIndex].id==oTriggerObject.eventid)
		            return dss.validValue.ok;
		    }
            
            return dss.validValue.completlyWrong;
	 	}
	 	case 'device-scene':  {
            var oDevice = dss.staticDataModel.getDevice(oTriggerObject.dsuid);
            if (oDevice.present===null) {
                return dss.validValue.completlyWrong;  // gel�schtes ger�t -> vollkommen falsch
            }
            if (!oDevice.present) {
                return dss.validValue.temporaryWrong;  // nicht vorhandene Geraete -> Fehler
            }
            if (oDevice.tasterMode != 0)  {
            	return dss.validValue.completlyWrong;	// reconfigured device
            }
            if (oTriggerObject.scene==null) {		
            	return dss.validValue.completlyWrong;
            }
            switch (oTriggerObject.scene)
            {
	            case 50:
	            	return dss.validValue.ok;
	            case 51:
	            	return dss.validValue.ok;
            }
            return dss.validValue.temporaryWrong;
	 	}
	 	case 'device-msg':  {
            var oDevice = dss.staticDataModel.getDevice(oTriggerObject.dsuid);
            if (oDevice.present===null) {
                return dss.validValue.completlyWrong;  // gel�schtes ger�t -> vollkommen falsch
            }
            if (!oDevice.present) {
                return dss.validValue.temporaryWrong;  // nicht vorhandene Geraete -> Fehler
            }
            if (oDevice.tasterMode != 15) {		// the device is not anymore configured as pushbutton
            	return dss.validValue.completlyWrong;
            }
            if (oTriggerObject.msg==null) {
            	return dss.validValue.completlyWrong;  
            }
            switch (oTriggerObject.msg) {
            	case 0: 
            		if ((oTriggerObject.buttonIndex != null) && (oDevice.buttonType != 2))  {
            			return dss.validValue.completlyWrong;
            		} else {
            			return dss.validValue.ok;
            		}
            		break;
            	case 7:
	            case 8:
	            case 1:
	            case 9:
	            case 2:
	            case 3:
	            case 6:
	            case 10:            	
	            	return dss.validValue.ok;
            }
            return dss.validValue.completlyWrong;
	 	}
	 	case 'device-binary-input':  {
            var oDevice = dss.staticDataModel.getDevice(oTriggerObject.dsuid);
            if (oDevice.present===null) {
                return dss.validValue.completlyWrong;  // gel�schtes ger�t -> vollkommen falsch
            }
            if (!oDevice.present) {
                return dss.validValue.temporaryWrong;  // nicht vorhandene Geraete -> Fehler
            }
            if ((oDevice.tastermode != 15) || !(16 <= oDevice.inputType <= 21)) {
            	return dss.validValue.completlyWrong;  // reconfigured device
            }
            if (oTriggerObject.state==null)
            	return dss.validValue.completlyWrong;  
            switch (oTriggerObject.state) {
	            case 0:
	            case 1:
	            	return dss.validValue.ok;
            }
            return dss.validValue.completlyWrong;
	 	}
	 	case 'undo-zone-scene':
            var oSceneObject=dss.staticDataModel.getScene(oTriggerObject.zone,oTriggerObject.group,oTriggerObject.scene);
            if (oSceneObject==null)
                return dss.validValue.completlyWrong;
            if (oSceneObject.undoable==null)
                return dss.validValue.completlyWrong;
            return (oSceneObject.undoable?dss.validValue.ok:dss.validValue.completlyWrong);  
	 	case 'zone-scene':
	 	case 'bus-zone-scene':
            if (oTriggerObject.zone==0) {
                // Apartment
                if (oTriggerObject.group!=0) {
                    if (oTriggerObject.scene>63)
                        return dss.validValue.completlyWrong; // apartment-szenen und raumszenen sind
										// immer falsch
                    var oGroups=dss.staticDataModel.getGroupForZone(oTriggerObject.zone);
                    for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                        if (oGroups[iIndex].group==oTriggerObject.group)
                            return (oGroups[iIndex].reachable?dss.validValue.ok:dss.validValue.temporaryWrong); // nur wenn
																// gruppe
																// erreichbar
																// ist, dann
																// kann aktion
																// laufen
                    }
                    return dss.validValue.completlyWrong; // gruppe ist nicht in der liste mit drin
                } else {
                    if (oTriggerObject.scene>63)
                        return dss.validValue.ok; // Alle R�ume + Deepoff ist auswaehlbar,
										// daher hier genehmigt
                    else
                        return dss.validValue.completlyWrong;
                }
            } else {
                // Zone
                var oZones=dss.staticDataModel.getZoneArray();
                var fValue=false;
                for (var iIndex=0;iIndex<oZones.length;iIndex++) {
                    if (oZones[iIndex].ZoneID==oTriggerObject.zone)
                        fValue=true;
                }
                if (oTriggerObject.zone==-1)
                	fValue=true;
                
                if (fValue==false)
                    return dss.validValue.completlyWrong; // zone is not valid
                if (oTriggerObject.group==0) {
                    if (oTriggerObject.scene==64)
                        return dss.validValue.ok;
                    if (oTriggerObject.scene==67)
                        return dss.validValue.ok;
                    if (oTriggerObject.scene==68)
                        return dss.validValue.ok;
                    if (oTriggerObject.scene==69)
                        return dss.validValue.ok;
                    if (oTriggerObject.scene==70)
                        return dss.validValue.ok;
                    return dss.validValue.completlyWrong;
                } else {
                    if (oTriggerObject.scene>63)
                        return dss.validValue.completlyWrong; // apartment-szenen und raumszenen sind
										// immer falsch
                    if (oTriggerObject.zone==-1)
                    	return dss.validValue.ok;
                    
                    var oGroups=dss.staticDataModel.getGroupForZone(oTriggerObject.zone);
                    for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                        if (oGroups[iIndex].group==oTriggerObject.group)
                            return (oGroups[iIndex].reachable?dss.validValue.ok:dss.validValue.temporaryWrong); // nur wenn
																// gruppe
																// erreichbar
																// ist, dann
																// kann aktion
																// laufen
                    }
                    return dss.validValue.completlyWrong; // gruppe ist nicht in der liste mit drin
                }
            }
            
            break;
	 	case 'custom-event': {
            for (var iIndex=0;iIndex<dss.staticDataModel.getHLE().length;iIndex++) {
                if (""+ dss.staticDataModel.getHLE()[iIndex].id==oTriggerObject.event) {
                    return dss.validValue.ok;
                }
            }
            return dss.validValue.completlyWrong;
	 	}
	 }
	 return dss.validValue.completlyWrong;
};

dss.validateActionObject = function (oActionObject) {
    var fValue=dss.validValue.ok;
    switch (oActionObject.type) {
 		case 'change-state' : {
 			if (oActionObject.statename.split('_')[0]=='uds') {
 				var idString =oActionObject.statename.split('_')[1];
 				var oUserStates=dss.staticDataModel.getUserStates();
    			var sStringValue;
    			for (var iIndex=0;iIndex<oUserStates.length;iIndex++) {
        			if (oUserStates[iIndex].id==idString) {
    	 				if (oActionObject.state=='active')
    	 					return dss.validValue.ok;
    	 				if (oActionObject.state=='inactive')
    	 					return dss.validValue.ok;
        			}
    			}
 			}
	 		switch (oActionObject.statename) {
	 			case 'fire':
	 			case 'hail':
	 			case 'rain':
	 			case 'wind':
	 				if (oActionObject.state=='active')
	 					return dss.validValue.ok;
	 				if (oActionObject.state=='inactive')
	 					return dss.validValue.ok;
		 			break;
	 		}
	 	}
        case 'zone-value': {
            return dss.validValue.completlyWrong; // nicht mehr unterstuetzt
            break;
        } 
        case 'heating-mode' : {
        	if (dss.staticDataModel.heating[oActionObject.zone].receiveOperationMode)
        		if (oActionObject.mode<6)
        			return dss.validValue.ok;
    		return dss.validValue.completlyWrong;            
        	break;
        }
        case 'zone-scene': {
            if (oActionObject.zone==0) {
                // Apartment
                if (dss.staticDataModel.isClusterGroup(oActionObject.group)) {
                	if (oActionObject.scene==90)
                        return dss.validValue.ok; // A
                	if (oActionObject.scene==91)
                        return dss.validValue.ok; // A
                }
            	
            	if (oActionObject.group!=0) {
                    if (oActionObject.scene>63)
                        return dss.validValue.completlyWrong; // apartment-szenen und raumszenen sind
										// immer falsch
                    var oGroups=dss.staticDataModel.getGroupForZone(oActionObject.zone);
                    for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                        if (oGroups[iIndex].group==oActionObject.group)
                            return (oGroups[iIndex].reachable?dss.validValue.ok:dss.validValue.temporaryWrong); // nur wenn
																// gruppe
																// erreichbar
																// ist, dann
																// kann aktion
																// laufen
                    }
                    return dss.validValue.completlyWrong; // gruppe ist nicht in der liste mit drin
                } else {
                    if (oActionObject.scene>63)
                        return dss.validValue.ok; // Alle R�ume + Deepoff ist auswaehlbar,
										// daher hier genehmigt
                    else
                        return dss.validValue.completlyWrong;
                }
            } else {
                // Zone
                var oZones=dss.staticDataModel.getZoneArray();
                var fValue=false;
                for (var iIndex=0;iIndex<oZones.length;iIndex++) {
                    if (oZones[iIndex].ZoneID==oActionObject.zone)
                        fValue=true;
                }
                if (oActionObject.group==6)
                	if (oActionObject.scene<64)
                		return dss.validValue.completlyWrong; // zone is not valid
                if (oActionObject.group==7)
                	if (oActionObject.scene<64)
                		return dss.validValue.completlyWrong; // zone is not valid
                if (fValue==false)
                    return dss.validValue.completlyWrong; // zone is not valid
                if (oActionObject.group==0) {
                    if (oActionObject.scene==64)
                        return dss.validValue.ok;
                    if (oActionObject.scene==67)
                        return dss.validValue.ok;
                    if (oActionObject.scene==68)
                        return dss.validValue.ok;
                    if (oActionObject.scene==69)
                        return dss.validValue.ok;
                    if (oActionObject.scene==70)
                        return dss.validValue.ok;
                    return dss.validValue.completlyWrong;
                } else {
                    if (oActionObject.scene>63)
                        return dss.validValue.completlyWrong; // apartment-szenen und raumszenen sind
										// immer falsch
                    var oGroups=dss.staticDataModel.getGroupForZone(oActionObject.zone);
                    for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                        if (oGroups[iIndex].group==oActionObject.group)
                            return (oGroups[iIndex].reachable?dss.validValue.ok:dss.validValue.temporaryWrong); // nur wenn
																// gruppe
																// erreichbar
																// ist, dann
																// kann aktion
																// laufen
                    }
                    return dss.validValue.completlyWrong; // gruppe ist nicht in der liste mit drin
                }
            }
            
            break;
        }
        case 'undo-zone-scene': {
            var oSceneObject=dss.staticDataModel.getScene(oActionObject.zone,oActionObject.group,oActionObject.scene);
            if (oSceneObject==null)
                return dss.validValue.completlyWrong;
            if (oSceneObject.undoable==null)
                return dss.validValue.completlyWrong;
            return (oSceneObject.undoable?dss.validValue.ok:dss.validValue.completlyWrong);            
        }
        case 'device-scene': { // device ohne ausgang!
            var oDevice = dss.staticDataModel.getDevice(oActionObject.dsuid);
            if (oDevice.present===null) {
                return dss.validValue.completlyWrong;  // gel�schtes ger�t -> vollkommen falsch
            }
            if (!oDevice.present) {
                return dss.validValue.temporaryWrong;  // nicht vorhandene Geraete -> Fehler
            }
            
            if (oDevice.specialActions.actions!=null)
                if (oDevice.specialActions.actions.deviceActions!=null) {
                	for (var sKey in oDevice.specialActions.actions.deviceActions) {
                		if (oDevice.specialActions.actions.deviceActions[sKey].scene!=null)
                			if (oDevice.specialActions.actions.deviceActions[sKey].scene==oActionObject.scene) {                    				
                				return dss.validValue.ok;                    				
                			}
                	}
                }
            
            
            if (oDevice.outputMode==0) {
                return dss.validValue.completlyWrong;
            }
            if (oActionObject.scene>63) {
                return dss.validValue.completlyWrong;
            }
            return dss.validValue.ok;
            break;
        }
        case 'device-value': {
            var oDevice = dss.staticDataModel.getDevice(oActionObject.dsuid);
            if (oDevice.present===null) {
                return dss.validValue.completlyWrong;  // gel�schtes ger�t -> vollkommen falsch
            }
            if (!oDevice.present) {
                return dss.validValue.temporaryWrong;  // nicht vorhandene Geraete -> Fehler
            }
            
            if (oDevice.specialActions.actions!=null)
                if (oDevice.specialActions.actions.deviceActions!=null) {
                	for (var sKey in oDevice.specialActions.actions.deviceActions) {
                		
                		if (oDevice.specialActions.actions.deviceActions[sKey].outputValue!=null)
                			if (oDevice.specialActions.actions.deviceActions[sKey].outputValue==oActionObject.value) {
                				return dss.validValue.ok;                  				
                			}

                	}
                }
            
            if (oDevice.outputMode==34) {
            	if (oActionObject.value==0)
            		return dss.validValue.ok;
            	if (oActionObject.value==128)
            		return dss.validValue.ok;
            	if (oActionObject.value==255)
            		return dss.validValue.ok;
            }
            if (oDevice.outputMode==38) {
            	if (oActionObject.value==0)
            		return dss.validValue.ok;
            	if (oActionObject.value==96)
            		return dss.validValue.ok;
            	if (oActionObject.value==160)
            		return dss.validValue.ok;
            	if (oActionObject.value==255)
            		return dss.validValue.ok;
            }
            
            return dss.validValue.completlyWrong; // nicht mehr unterstuetzt
            break;
        }
        case 'device-blink': {
            var oDevice = dss.staticDataModel.getDevice(oActionObject.dsuid);
            if (oDevice.present===null) {
                return dss.validValue.completlyWrong;  // gel�schtes ger�t -> vollkommen falsch
            }
            if (!oDevice.present) {
                return dss.validValue.temporaryWrong;  // nicht vorhandene Geraete -> Fehler
            }
            if (oDevice.outputMode==0) {
                return dss.validValue.completlyWrong;
            }
            return dss.validValue.ok;
            break;
        }
        case 'zone-blink': {
            if (oActionObject.zone==0) {
                if (oActionObject.group==1) { // nur licht darf blinken
                    return dss.validValue.ok;
                } else {
                	if (dss.staticDataModel.getUserGroupColor(oActionObject.group)==1) // gelbe benutzergruppen aber auch
                		return dss.validValue.ok;
                    return dss.validValue.completlyWrong;
                }
            }
            var oZones=dss.staticDataModel.getZoneArray();
            var fValue=dss.validValue.completlyWrong;
            for (var iIndex=0;iIndex<oZones.length;iIndex++) {
                if (oZones[iIndex].ZoneID==oActionObject.zone)
                    fValue=dss.validValue.ok;
            }
            if (fValue==dss.validValue.completlyWrong)
                return dss.validValue.completlyWrong;
            if (oActionObject.group!=1) // nur licht darf blinken
                return dss.validValue.completlyWrong;
            var oGroups=dss.staticDataModel.getGroupForZone(oActionObject.zone);
            for (var iIndex=0;iIndex<oGroups.length;iIndex++) {
                if (oGroups[iIndex].group==oActionObject.group)
                    return (oGroups[iIndex].reachable?dss.validValue.ok:dss.validValue.temporaryWrong); // falls licht da ist,
														// dann blinkt es nur
														// dann, wenn es
														// reachable ist
            }
            return dss.validValue.completlyWrong;
            break;
        }
        case 'custom-event': {
            for (var iIndex=0;iIndex<dss.staticDataModel.getHLE().length;iIndex++) {
                if (""+ dss.staticDataModel.getHLE()[iIndex].id==oActionObject.event) {
                    return dss.validValue.ok;
                }
            }
            return dss.validValue.completlyWrong;
            break;
        }
        case 'url' : {
            return dss.validValue.ok;
            break;
        }
        default: 
            return dss.validValue.completlyWrong;
        break;
    }
    return dss.validValue.completlyWrong;
};

/*
 * als default wird framework/locale/{languageSuffix}/dss-addon-framework.po
 * geladen es k�nnen aber auch weitere urls angegeben werden, wobei
 * {languageSuffix} durch den zweiten parameter ersetzt wird oLangdefinition
 * m�ssen ['url'] sein
 */
dss.buildUpLang=function(oLangDefinitions,languageSuffix) {
    /*
	 * _ = function (s) { if (dss.translation[s]==null) return s; return
	 * dss.translation[s]; }
	 */
    
    var params = {  
            domain : "dss-addon-framework",
            locale_data : {}
    };
    
    if (languageSuffix==null) {
        var oLang=Ext.JSON.decode(dss.ajaxSyncRequest('/json/property/query',{query:'/system/language(locale)'}));
        if (oLang!=null)
            if (oLang.ok && (oLang.result.language[0] !== undefined)) {
                languageSuffix=oLang.result.language[0].locale;
            } else {
                languageSuffix="en_US";
            }
    }
    if (languageSuffix==null)
        languageSuffix='de_DE';
    dss.staticDataModel.activeLanguage=languageSuffix;
    if (oLangDefinitions==null)
        oLangDefinitions=[];
    
    oLangDefinitions.splice(0,0,'/framework/locale/{languageSuffix}/dss-addon-framework.po');
    locale_ = {};
    for (var lIndex=0;lIndex<oLangDefinitions.length;lIndex++) {
        var sDomain=params.domain;
        
        var sURL=Ext.String.format2(oLangDefinitions[lIndex],{'languageSuffix':dss.staticDataModel.activeLanguage},false);
        
        if (params.locale_data[sDomain]==null)
            params.locale_data[sDomain]={};
        
        var sString=dss.ajaxSyncRequest(sURL,{});
        
        var oArray=sString.split('\n');
        var iState=0;
        var sMSGID=null;
        var msgid;
        var msgstr;
        function ltrim(sString){return sString.replace(/^\s+/,'');}
        for (var iIndex=0;iIndex<oArray.length;iIndex++)
        {
            if (oArray[iIndex][0]=='#') {
            	iState=0;
            } else if (oArray[iIndex].indexOf("msgid")>-1) {
                iState=1;
                msgid=oArray[iIndex].substr(oArray[iIndex].indexOf('"')+1);
                msgid=msgid.substr(0,msgid.lastIndexOf('"'));
            } else if (oArray[iIndex].indexOf("msgstr")>-1) {
                if (iState==1) {
                    iState=2;
                    msgstr=oArray[iIndex].substr(oArray[iIndex].indexOf('"')+1);
                    msgstr=msgstr.substr(0,msgstr.lastIndexOf('"'));
                    params.locale_data[sDomain][msgid]=[null,msgstr];                    
                }
            } else { 
                if (iState ==1) {
                    var sTempString=oArray[iIndex];
                    sTempString=ltrim(sTempString);
                    if (sTempString[0]=='"') {
                        sTempString=sTempString.substr(1);
                        sTempString=sTempString.substr(0,sTempString.lastIndexOf('"'));
                        msgid+=sTempString;
                    }
                }
                if (iState==2) {            	
                	var sTempString=oArray[iIndex];
                	sTempString=ltrim(sTempString);
                	if (sTempString[0]=='"') {
                		sTempString=sTempString.substr(1);
                		sTempString=sTempString.substr(0,sTempString.lastIndexOf('"'));
                		msgstr+=sTempString;
                		params.locale_data[sDomain][msgid]=[null,msgstr]; 
                	} else {
                		oState=0;
                	}
                }
            }
        }
    }

    dss.staticDataModel.gt = new Gettext(params);

    Ext.Date.dayNames = [ _('sunday'), _('monday'), _('tuesday'), _('wednesday'), _('thursday'), _('friday'), _('saturday') ];
    Ext.Date.monthNames = [ _('january'), _('february'), _('march'), _('april'), _('may'), _('june'), _('july'), _('august'), _('september'), _('october'), _('november'), _('december') ];
    
};

dss.cloudAvaible=null;

dss.isCloudAvaible = function(fRefresh){
	if (fRefresh==null)
		if (dss.cloudAvaible!=null)
			return dss.cloudAvaible;
	if (fRefresh==false)
		if (dss.cloudAvaible!=null)
			return dss.cloudAvaible;
	dss.cloudAvaible=false;
    var resultObj;
    var sResponseRemoteAccess = dss.ajaxSyncRequest('/cgi-bin/remoteaccessinfo.sh', {});
    try {
        resultObj = Ext.JSON.decode(sResponseRemoteAccess);
        if (resultObj.success) {
            if (null !== resultObj.data.remoteaccess) {
            	dss.cloudAvaible = resultObj.data.remoteaccess;
            }
        }
    } catch(e) {}
    return dss.cloudAvaible;
}


dss.pushAndQuery=function(eventName,parameter,answerEvent,callbackFunction) {
	if (dss.activeSubscription!=null)
		dss.endSubscription();
	
    dss.activeSubscription={
    	id:Math.floor(Math.random() * 100000000000),
    	name:answerEvent,
    	callback:callbackFunction
    };
     
    dss.ajaxSyncRequest('/json/event/subscribe', {
        subscriptionID : dss.activeSubscription.id,
        name : dss.activeSubscription.name
    });
    
    
    dss.raiseEvent(eventName, parameter);
    
    dss.refreshListener();

}

dss.activeSubscription=null;

dss.makeSubscription=function(eventName,callbackFunction) {
       
    dss.activeSubscription={
    	id:Math.floor(Math.random() * 100000000000),
    	name:eventName,
    	callback:callbackFunction
    };
    
    dss.ajaxSyncRequest('/json/event/subscribe', {
        subscriptionID : dss.activeSubscription.id,
        name : dss.activeSubscription.name
    });
    dss.refreshListener();
} 

dss.refreshListener=function() {
	   dss.ajaxAssyncRequestWithoutAnswer('/json/event/get', {
	        subscriptionID : dss.activeSubscription.id,
	        timeout : 5*1000
	    }, function(answer) {
	    	var result = Ext.JSON.decode(answer);
	    	if (result.ok==false) {
	    		if (dss.activeSubscription!=null) {
	    			dss.activeSubscription.id=Math.floor(Math.random() * 100000000000);
	    		    dss.ajaxSyncRequest('/json/event/subscribe', {
	    		        subscriptionID : dss.activeSubscription.id,
	    		        name : dss.activeSubscription.name
	    		    });
	    		    dss.refreshListener();
	    		    return;
	    		}
				return;	    			    		
	    	} else {
	    		var fRepeat=true;
	    		if (result.result!=null)
	    			if (result.result.events!=null)
			    		for (var iIndex=0;iIndex<result.result.events.length;iIndex++) { 
			    			if (dss.activeSubscription.callback(result.result.events[iIndex])===true)
			    				fRepeat=false;
			    		}
	    		if (fRepeat)
	    			dss.refreshListener();
	    		else
	    			dss.endSubscription();
	    	} 	
	    	
	    });	
}

dss.endSubscription=function() {
	 dss.ajaxAssyncRequestWithoutAnswer('/json/event/unsubscribe', {
         subscriptionID : dss.activeSubscription.id,
         name : dss.activeSubscription.name
     });
	dss.activeSubscription=null;	
}

/**
 * Gettext translation method
 * 
 * @param {String}
 *            msgid The string to translate
 * @param {String}
 *            arg1 Typically the plural form
 * @param {int}
 *            arg1 Typically the count
 * @return {String} The translated string if available, otherwise return msgid
 */
function _(msgid, arg1, arg2) {
    if (dss.staticDataModel.gt) {
        if (arguments.length === 1) {
            return dss.staticDataModel.gt.gettext(msgid);
        } else if (arguments.length === 2) {
            return dss.staticDataModel.gt.ngettext(msgid, arg1);
        } else if (arguments.length === 3) {
            return dss.staticDataModel.gt.ngettext(msgid, arg1, arg2);
        }
    }
    return msgid;
}

